; Various subroutines (used to live at $3800)

GameSetup               LD HL,UDKTab                    ;
                        EXX                             ;
                        LD B,7                          ;
                        LD IY,ukLeft                    ;
                        LD IX,KeyWorkspace              ;
GLoop1                  LD (IY),$C3                     ;
                        INC IY                          ;
                        PUSH IX                         ;
                        POP HL                          ;
                        LD (IY),L                       ;
                        INC IY                          ;
                        LD (IY),H                       ;
                        INC IY                          ;
                        PUSH IY                         ;
                        PUSH BC                         ;
                        CALL Compile                    ;
                        POP BC                          ;
                        POP IY                          ;
                        DJNZ GLoop1                     ;

                        HALT                            ;
                        DI                              ;

                        LD HL,IntRoutGame               ;
                        LD (jIntRout+1),HL              ;
                        CALL InitScore                  ;
                        CALL InitClock                  ;

                        LD HL,pBarAddr+$800             ;
                        LD (pBar),HL                    ;

                        LD A,0                          ;
                        LD (AEnergy),A                  ;
                        LD A,$88                        ;
                        LD (BarBit),A                   ;

                        LD A,Cls                        ;
                        CALL Print                      ;

                        LD IX,pBarAddr                  ;
                        LD HL,$070F                     ;
                        LD DE,$0F0F                     ;
                        LD A,$0F                        ;
                        LD B,35                         ;
                        CALL DBHori                     ;
                        LD IX,pBarAddr+$1800            ;
                        CALL DBHori                     ;

                        LD HL,pBarAddr+$800             ;
                        LD C,$08                        ;
                        LD B,2                          ;
                        CALL DBVert                     ;
                        LD HL,pBarAddr+$800+39          ;
                        LD C,$08                        ;
                        LD B,2                          ;
                        CALL DBVert                     ;

                        CALL FrameSync                  ;
                        EI                              ;

                        CALL Game                       ;

                        PUSH HL                         ;
                        PUSH AF                         ;
                        DI                              ;
                        CALL DieMortal                  ;
                        LD HL,Ret                       ;
                        LD (jIntRout+1),HL              ;
                        CALL FrameSync                  ;
                        EI                              ;
                        POP AF                          ;
                        POP HL                          ;
                        RET                             ;

FrameSync               LD BC,PIOb                      ;
FS1                     IN A,(C)                        ;
                        BIT 0,A                         ;
                        JR NZ FS1                       ;

FS2                     IN A,(C)                        ;
                        BIT 0,A                         ;
                        JR Z FS2                        ;

                        RET                             ;

DieMortal               LD HL,Colours                   ;
                        LD DE,TempColours               ;
                        LD BC,17                        ;
                        LDIR                            ;

                        LD BC,ULA or $8C                ;
                        OUT (C),C                       ;

                        LD B,$09                        ;
DieM1                   PUSH BC                         ;
                        CALL DimCols                    ;
                        CALL OutPall                    ;
                        CALL FrameSync                  ;
                        POP BC                          ;
                        DJNZ DieM1                      ;

                        LD A,Cls                        ;
                        CALL Print                      ;
                        RET                             ;

DimCols                 LD HL,TempColours               ;

DClp                    LD A,(HL)                       ;
                        CP $FF                          ;
                        RET Z                           ;

                        CP 20                           ;
                        JR Z DC3                        ;

                        LD DE,FadeTable                 ;
                        LD B,A                          ;
DC1                     LD A,(DE)                       ;
                        CP B                            ;
                        JR Z DC2                        ;

                        INC DE                          ;
                        JR DC1                          ;

DC2                     DEC DE                          ;
                        LD A,(DE)                       ;
                        LD (HL),A                       ;
DC3                     INC HL                          ;
                        JR DClp                         ;

OutPall                 LD HL,TempColours               ;
                        LD BC,ULA                       ;
OPlp                    LD A,(HL)                       ;
                        CP $FF                          ;
                        RET Z                           ;

                        OUT (C),C                       ;
                        AND $1F                         ;
                        OR $40                          ;
                        OUT (C),A                       ;
                        INC C                           ;
                        INC HL                          ;
                        JR OPlp                         ;

IntRoutGame             PUSH IY                         ;
                        PUSH IX                         ;
                        LD A,(DEnergy)                  ;
                        LD B,A                          ;
                        LD A,(AEnergy)                  ;
                        CP B                            ;
                        CALL NZ StepBar                 ;
                        LD A,(SecCount)                 ;
                        AND $01                         ;
                        CALL NZ SScore                  ;
                        LD A,(SecCount)                 ;
                        DEC A                           ;
                        LD (SecCount),A                 ;
                        CP 25                           ;
                        CALL Z FlipColons               ;
                        LD A,(SecCount)                 ;
                        OR A                            ;
                        CALL Z SetUpSec                 ;
                        LD A,(Slice)                    ;
                        OR A                            ;
                        JR Z Int1                       ;

                        DEC A                           ;
                        LD (Slice),A                    ;
                        CALL SClock                     ;
Int1                    CALL FrameInt                   ;
                        POP IX                          ;
                        POP IY                          ;
                        RET                             ;

StepBar                 LD HL,(pBar)                    ;
                        LD A,(BarBit)                   ;
                        JR C SBr                        ;

                        CALL DrarBar                    ;
                        LD A,(AEnergy)                  ;
                        DEC A                           ;
                        LD (AEnergy),A                  ;
                        LD A,(BarBit)                   ;
                        RLCA                            ;
                        LD (BarBit),A                   ;
                        RET NC                          ;

                        DEC HL                          ;
                        LD (pBar),HL                    ;
                        RET                             ;

SBr                     RRCA                            ;
                        LD (BarBit),A                   ;
                        JR NC SB1                       ;

                        INC HL                          ;
                        LD (pBar),HL                    ;
SB1                     CALL DrarBar                    ;
                        LD A,(AEnergy)                  ;
                        INC A                           ;
                        LD (AEnergy),A                  ;
                        RET                             ;

DrarBar                 PUSH HL                         ;
                        LD B,A                          ;
                        XOR (HL)                        ;
                        LD (HL),A                       ;
                        LD A,H                          ;
                        ADD A,$08                       ;
                        LD H,A                          ;
                        LD A,B                          ;
                        XOR (HL)                        ;
                        LD (HL),A                       ;
                        POP HL                          ;
                        RET                             ;

InitScore               LD HL,$0000                     ;
                        LD (DScore),HL                  ;
                        LD (AScore),HL                  ;
                        LD HL,ScoreBuff+3               ;
                        LD (SSpU),HL                    ;
                        LD A,9                          ;
                        LD (SScnt),A                    ;
                        LD A,5                          ;
                        LD (SSc),A                      ;
                        LD HL,pScore+2                  ;
                        LD (SSpD),HL                    ;
                        LD HL,ScoreData                 ;
                        LD DE,ScoreBuff                 ;
                        LD BC,15                        ;
                        LDIR                            ;
                        RET                             ;

SetUpSec                LD A,8                          ;
                        LD (Slice),A                    ;
                        LD A,$32                        ;
                        LD (SecCount),A                 ;
                        CALL AddOne                     ;
                        LD A,B                          ;
                        LD (nScroll),A                  ;
                        JP FlipColons                   ;

AddOne                  LD DE,FirstDig                  ;
                        LD HL,p1                        ;
                        LD B,1                          ;
                        CALL DoTen                      ;
                        RET C                           ;

                        CALL DoSix                      ;
                        RET C                           ;

                        CALL DoTen                      ;
                        RET C                           ;

                        CALL DoSix                      ;
                        RET C                           ;

                        CALL DoTen                      ;
                        RET C                           ;

                        CALL DoTen                      ;
                        DEC B                           ;
                        RET                             ;

DoTen                   LD A,(DE)                       ;
                        INC A                           ;
                        LD (DE),A                       ;
                        CP 10                           ;
                        RET C                           ;

                        LD (HL),low cZero               ;
                        INC HL                          ;
                        LD (HL),high cZero              ;
                        INC HL                          ;
                        XOR A                           ;
                        LD (DE),A                       ;
                        INC B                           ;
                        INC DE                          ;
                        RET                             ;

DoSix                   LD A,(DE)                       ;
                        INC A                           ;
                        LD (DE),A                       ;
                        CP 6                            ;
                        RET C                           ;

                        LD (HL),low cZero               ;
                        INC HL                          ;
                        LD (HL),high cZero              ;
                        INC HL                          ;
                        XOR A                           ;
                        LD (DE),A                       ;
                        INC B                           ;
                        INC DE                          ;
                        RET                             ;

SClock                  LD IX,p1                        ;
                        LD C,0                          ;
nScroll                 EQU *-1                         ;
SClp                    LD E,(IX)                       ;
                        LD D,(IX+1)                     ;
                        LD L,(IX+12)                    ;
                        LD H,(IX+13)                    ;
                        LD B,$08                        ;
SClp1                   LD A,(DE)                       ;
                        LD (HL),A                       ;
                        INC DE                          ;
                        INC HL                          ;
                        LD A,(DE)                       ;
                        LD (HL),A                       ;
                        DEC HL                          ;
                        INC DE                          ;
                        LD A,H                          ;
                        ADD A,$08                       ;
                        LD H,A                          ;
                        DJNZ SClp1                      ;

                        INC (IX)                        ;
                        INC (IX)                        ;
                        INC IX                          ;
                        INC IX                          ;
                        DEC C                           ;
                        JR NZ SClp                      ;

                        RET                             ;

InitClock               LD HL,ClockData                 ;
                        LD DE,p1                        ;
                        LD BC,30                        ;
                        LDIR                            ;
                        LD A,1                          ;
                        LD (SecCount),A                 ;
                        DEC A                           ;
                        LD (Slice),A                    ;
                        LD A,$FF                        ;
                        LD (ColonF),A                   ;
                        RET                             ;

FlipColons              LD A,(ColonF)                   ;
                        XOR $FF                         ;
                        LD (ColonF),A                   ;

                        LD DE,$0000                     ;
                        JR NZ FCa                       ;
                        LD DE,$11CC                     ;
FCa                     LD HL,Colon1                    ;
                        CALL FCb                        ;
                        LD HL,Colon2                    ;
FCb                     CALL FCc                        ;
                        LD A,H                          ;
                        ADD A,$10                       ;
                        LD H,A                          ;
FCc                     LD (HL),D                       ;
                        INC HL                          ;
                        LD (HL),E                       ;
                        DEC HL                          ;
                        LD A,H                          ;
                        ADD A,$08                       ;
                        LD H,A                          ;
                        LD (HL),D                       ;
                        INC HL                          ;
                        LD (HL),E                       ;
                        DEC HL                          ;
                        LD A,H                          ;
                        ADD A,8                         ;
                        LD H,A                          ;
                        RET                             ;

SScore                  LD A,(SScnt)                    ;
                        DEC A                           ;
                        JR NZ SSscr                     ;

                        LD HL,(AScore)                  ;
                        LD DE,(DScore)                  ;
                        OR A                            ;
                        SBC HL,DE                       ;
                        RET Z                           ;

                        EX DE,HL                        ;
                        LD (AScore),HL                  ;
                        LD IX,ScoreBuff                 ;
                        LD B,5                          ;
                        LD DE,pScore                    ;
SScl                    CALL RotDig                     ;
                        DEC B                           ;
                        INC DE                          ;
                        INC DE                          ;
                        INC IX                          ;
                        INC IX                          ;
                        INC IX                          ;
                        OR A                            ;
                        JR Z SScl                       ;

SSc2                    ADD A,A                         ;
                        ADD A,A                         ;
                        ADD A,A                         ;
                        ADD A,A                         ;
                        ADD A,low ScZero                ;
                        CP (IX-3)                       ;
                        JR NZ SSc4                      ;

                        DEC B                           ;
                        INC DE                          ;
                        INC DE                          ;
                        CALL RotDig                     ;
                        INC IX                          ;
                        INC IX                          ;
                        INC IX                          ;
                        JR SSc2                         ;

SSc4                    LD (SSpU),IX                    ;
                        LD (SSpD),DE                    ;
                        PUSH AF                         ;
                        LD A,B                          ;
                        INC A                           ;
                        LD (SSc),A                      ;
                        POP AF                          ;
                        JR SSc5                         ;

SSc3                    ADD A,A                         ;
                        ADD A,A                         ;
                        ADD A,A                         ;
                        ADD A,A                         ;
                        ADD A,$10                       ;
SSc5                    LD (IX-3),A                     ;
                        LD (IX-1),A                     ;
                        CALL RotDig                     ;
                        INC IX                          ;
                        INC IX                          ;
                        INC IX                          ;
                        DJNZ SSc3                       ;

                        LD A,8                          ;
SSscr                   LD (SScnt),A                    ;
                        SUB 9                           ;
                        NEG                             ;
                        LD (SScM),A                     ;
                        LD A,(SSc)                      ;
                        LD B,A                          ;
                        LD DE,(SSpD)                    ;
                        LD IX,(SSpU)                    ;
                        LD H,high cZero                 ;
SSlp                    PUSH BC                         ;
                        LD L,(IX-2)                     ;
                        INC (IX-2)                      ;
                        INC (IX-2)                      ;
                        LD A,$01                        ;
SScnt                   EQU *-1                         ;
                        DEC A                           ;
                        LD B,A                          ;
                        JR Z SS1x                       ;

SSl1                    LD A,(HL)                       ;
                        LD (DE),A                       ;
                        INC L                           ;
                        INC DE                          ;
                        LD A,(HL)                       ;
                        LD (DE),A                       ;
                        INC L                           ;
                        DEC DE                          ;
                        LD A,D                          ;
                        ADD A,$08                       ;
                        LD D,A                          ;
                        DJNZ SSl1                       ;

SS1x                    LD L,(IX-1)                     ;
                        LD A,0                          ;
SScM                    EQU *-1                         ;
                        OR A                            ;
                        JR Z SS2x                       ;

                        LD B,A                          ;
SSl2                    LD A,(HL)                       ;
                        LD (DE),A                       ;
                        INC L                           ;
                        INC DE                          ;
                        LD A,(HL)                       ;
                        LD (DE),A                       ;
                        INC L                           ;
                        DEC DE                          ;
                        LD A,D                          ;
                        ADD A,$08                       ;
                        LD D,A                          ;
                        DJNZ SSl2                       ;

SS2x                    INC IX                          ;
                        INC IX                          ;
                        INC IX                          ;
                        POP BC                          ;
                        LD A,D                          ;
                        SUB $08*8                       ;
                        LD D,A                          ;
                        INC DE                          ;
                        INC DE                          ;
                        DJNZ SSlp                       ;

                        LD A,(SScnt)                    ;
                        DEC A                           ;
                        RET NZ                          ;

                        LD HL,ScoreBuff                 ;
                        LD B,5                          ;
SS3                     LD A,(HL)                       ;
                        INC HL                          ;
                        LD (HL),A                       ;
                        INC HL                          ;
                        INC HL                          ;
                        DJNZ SS3                        ;

                        RET                             ;

RotDig                  XOR A                           ;
                        ADD HL,HL                       ;
                        RLA                             ;
                        ADD HL,HL                       ;
                        RLA                             ;
                        ADD HL,HL                       ;
                        RLA                             ;
                        ADD HL,HL                       ;
                        RLA                             ;
                        RET                             ;

Compile                 LD HL,KeyBuffer                 ;
                        LD B,10                         ;
Com1                    LD (HL),$FF                     ;
                        INC HL                          ;
                        DJNZ Com1                       ;

                        LD (IX),$06                     ;
                        INC IX                          ;
                        LD (IX),high PIOc               ;
                        INC IX                          ;

                        EXX                             ;
                        PUSH HL                         ;
                        LD BC,$10                       ;
                        ADD HL,BC                       ;
                        EXX                             ;
                        POP IY                          ;

Com2                    LD A,(IY)                       ;
                        INC IY                          ;
                        CP 80                           ;
                        JR NC Comx                      ;

                        CALL Conv                       ;
                        LD A,B                          ;
                        LD B,0                          ;
                        LD HL,KeyBuffer                 ;
                        ADD HL,BC                       ;
                        AND (HL)                        ;
                        LD (HL),A                       ;
                        JR Com2                         ;

Comx                    LD HL,KeyBuffer                 ;
                        LD B,10                         ;
                        LD C,$40                        ;
Com3                    LD A,(HL)                       ;
                        CP $FF                          ;
                        JR Z Com4                       ;

                        LD (IX),$0E                     ;
                        INC IX                          ;
                        LD (IX),C                       ;
                        INC IX                          ;
                        LD (IX),$ED                     ;
                        INC IX                          ;
                        LD (IX),$49                     ;
                        INC IX                          ;
                        LD (IX),$3E                     ;
                        INC IX                          ;
                        LD (IX),high PIOa               ;
                        INC IX                          ;
                        LD (IX),$DB                     ;
                        INC IX                          ;
                        LD (IX),$FF                     ;
                        INC IX                          ;
                        LD (IX),$F6                     ;
                        INC IX                          ;
                        LD (IX),A                       ;
                        INC IX                          ;
                        LD (IX),$3C                     ;
                        INC IX                          ;
                        LD (IX),$C0                     ;
                        INC IX                          ;
Com4                    INC HL                          ;
                        INC C                           ;
                        DJNZ Com3                       ;

                        LD (IX-1),$C9                   ;
                        RET                             ;

Conv                    LD B,A                          ;
                        RRCA                            ;
                        RRCA                            ;
                        RRCA                            ;
                        AND $0F                         ;
                        LD C,A                          ;
                        LD A,B                          ;
                        AND $07                         ;
                        LD B,$FE                        ;
ConvLp                  RET Z                           ;

                        RLC B                           ;
                        DEC A                           ;
                        JR ConvLp                       ;

                        LD HL,Screen                    ;
                        LD (pCurY),HL                   ;
                        LD HL,0                         ;
                        LD (pCurX),HL                   ;
                        LD A,0                          ;
                        LD (ppCurY),A                   ;
                        RET                             ;

DrawBorder              LD IX,$F0BC                     ;
                        LD HL,$0001                     ;
                        LD DE,$0800                     ;
                        LD A,$0F                        ;
                        LD B,$20                        ;
                        CALL DBHori                     ;
                        LD IX,$CE0C                     ;
                        CALL DBHori                     ;
                        LD HL,$F8BD                     ;
                        LD C,$02                        ;
                        LD B,$82                        ;
                        CALL DBVert                     ;
                        LD HL,$F8DE                     ;
                        LD C,$04                        ;
                        CALL DBVert                     ;
                        LD IX,$D8BC                     ;
                        LD HL,$00F0                     ;
                        LD DE,$F000                     ;
                        LD A,$F0                        ;
                        LD B,$20                        ;
                        CALL DBHori                     ;
                        LD IX,$E60C                     ;
                        CALL DBHori                     ;
                        LD HL,$E0BC                     ;
                        LD C,$10                        ;
                        LD B,$88                        ;
                        CALL DBVert                     ;
                        LD HL,$E0DF                     ;
                        LD C,$80                        ;
                        CALL DBVert                     ;
                        RET                             ;

DBHori                  PUSH HL                         ;
                        PUSH DE                         ;
                        PUSH BC                         ;
                        LD (IX),H                       ;
                        INC IX                          ;
                        LD (IX),L                       ;
                        PUSH IX                         ;
                        POP HL                          ;
                        INC HL                          ;
DBHlp                   LD (HL),A                       ;
                        INC HL                          ;
                        DJNZ DBHlp                      ;

                        LD (HL),D                       ;
                        INC HL                          ;
                        LD (HL),E                       ;
                        POP BC                          ;
                        POP DE                          ;
                        POP HL                          ;
                        RET                             ;

DBVert                  PUSH BC                         ;
DBVlp                   LD A,(HL)                       ;
                        OR C                            ;
                        LD (HL),A                       ;
                        LD A,H                          ;
                        ADD A,$08                       ;
                        LD H,A                          ;
                        JR NC DBVa                      ;

                        LD DE,80-$4000                  ;
                        ADD HL,DE                       ;
DBVa                    SET 7,H                         ;
                        SET 6,H                         ;
                        DJNZ DBVlp                      ;

                        POP BC                          ;
                        RET                             ;

                        align 256                       ;

cZero                   DEFB $33,$CC,$66,$66,$66,$66,$33,$EE;
                        DEFB $00,$66,$66,$66,$33,$CC,$00,$00;

ScZero                  DEFB $33,$CC,$66,$66,$66,$66,$66,$66;
                        DEFB $66,$66,$66,$66,$33,$CC,$00,$00;

                        DEFB $11,$88,$33,$88,$11,$88,$11,$88;
                        DEFB $11,$88,$11,$88,$77,$EE,$00,$00;

                        DEFB $33,$CC,$66,$66,$00,$66,$33,$CC;
                        DEFB $66,$00,$66,$66,$77,$EE,$00,$00;

                        DEFB $33,$CC,$66,$66,$00,$66,$11,$CC;
                        DEFB $00,$66,$66,$66,$33,$CC,$00,$00;

                        DEFB $11,$CC,$33,$CC,$66,$CC,$CC,$CC;
                        DEFB $FF,$EE,$00,$CC,$11,$EE,$00,$00;

                        DEFB $77,$EE,$66,$22,$66,$00,$77,$CC;
                        DEFB $00,$66,$66,$66,$33,$CC,$00,$00;

                        DEFB $33,$CC,$66,$66,$66,$00,$77,$CC;
                        DEFB $66,$66,$66,$66,$33,$CC,$00,$00;

                        DEFB $77,$EE,$66,$66,$00,$66,$00,$CC;
                        DEFB $11,$88,$11,$88,$11,$88,$00,$00;

                        DEFB $33,$CC,$66,$66,$66,$66,$33,$CC;
                        DEFB $66,$66,$66,$66,$33,$CC,$00,$00;

                        DEFB $33,$CC,$66,$66,$66,$66,$33,$EE;
                        DEFB $00,$66,$66,$66,$33,$CC,$00,$00;

cStart                  DEFB $00,$00,$00,$00,$00,$00,$00,$00;
                        DEFB $00,$00,$00,$00,$00,$00,$00,$00;

; More subroutines (used to live at $8000)

SetUpSubs               CALL PALL                       ;
                        CALL GenYTab                    ;
                        CALL Gen192Tab                  ;
                        CALL SetUpTabs                  ;
                        ;
                        LD A,0                          ;
                        CALL SetUpRot                   ;
                        LD A,1                          ;
                        CALL SetUpRot                   ;
                        ;
                        LD A,0                          ;
                        CALL SetUpRotA                  ;
                        LD A,1                          ;
                        CALL SetUpRotA                  ;
                        ;
                        LD HL,#0000                     ;
                        LD (OldLines1),HL               ;
                        LD (OldLines2),HL               ;
                        LD HL,OldLines1                 ;
                        LD (pLines),HL                  ;
                        LD HL,OldLines2                 ;
                        LD (pOLines),HL                 ;
                        LD A,#0F                        ;
                        LD (ColourMask),A               ;
                        RET                             ;
                        ;
nStopAC                 LD BC,PIOa or #08               ;
                        OUT (C),C                       ;
                        LD BC,PIOc or #C0               ;
                        OUT (C),C                       ;
                        XOR A                           ;
                        OUT (C),A                       ;
                        LD B,PIOa / 256                 ;
                        OUT (C),A                       ;
                        LD BC,PIOc or #80               ;
                        OUT (C),C                       ;
                        OUT (C),A                       ;
                        ;
                        LD BC,PIOa or #0A               ;
                        OUT (C),C                       ;
                        LD BC,PIOc or #C0               ;
                        OUT (C),C                       ;
                        OUT (C),A                       ;
                        LD B,PIOa / 256                 ;
                        OUT (C),A                       ;
                        LD BC,PIOc or #80               ;
                        OUT (C),C                       ;
                        OUT (C),A                       ;
                        LD BC,PIOa or #0E               ;
                        OUT (C),C                       ;
                        LD BC,PIOc or #C0               ;
                        OUT (C),C                       ;
                        OUT (C),A                       ;
                        LD BC,PIOk or #92               ;
                        OUT (C),C                       ;
                        LD (nvA),A                      ;
                        LD (nvC),A                      ;
                        LD BC,PIOc or #40               ;
                        OUT (C),C                       ;
                        RET                             ;
;
StartNoise              LD E,B                          ;
                        LD D,C                          ;
                        LD H,#95                        ;
                        LD BC,PIOk or #82               ;
                        OUT (C),C                       ;
                        LD BC,PIOa or #08               ;
                        OUT (C),C                       ;
                        LD BC,PIOc or #C0               ;
                        OUT (C),C                       ;
                        XOR A                           ;
                        OUT (C),A                       ;
                        LD B,PIOa / 256                 ;
                        OUT (C),E                       ;
                        LD BC,PIOc or #80               ;
                        OUT (C),C                       ;
                        OUT (C),A                       ;
                        ;
                        LD BC,PIOa or #0A               ;
                        OUT (C),C                       ;
                        LD BC,PIOc or #C0               ;
                        OUT (C),C                       ;
                        XOR A                           ;
                        OUT (C),A                       ;
                        LD B,PIOa / 256                 ;
                        OUT (C),D                       ;
                        LD BC,PIOc or #80               ;
                        OUT (C),C                       ;
                        OUT (C),A                       ;
                        ;
                        LD BC,PIOa or #06               ;
                        OUT (C),C                       ;
                        LD BC,PIOc or #C0               ;
                        OUT (C),C                       ;
                        XOR A                           ;
                        OUT (C),A                       ;
                        LD B,PIOa / 256                 ;
                        OUT (C),L                       ;
                        LD BC,PIOc or #80               ;
                        OUT (C),C                       ;
                        OUT (C),A                       ;
                        ;
                        LD BC,PIOa or #07               ;
                        OUT (C),C                       ;
                        LD BC,PIOc or #C0               ;
                        OUT (C),C                       ;
                        XOR A                           ;
                        OUT (C),A                       ;
                        LD B,PIOa / 256                 ;
                        OUT (C),H                       ;
                        LD BC,PIOc or #80               ;
                        OUT (C),C                       ;
                        OUT (C),A                       ;
                        ;
                        LD BC,PIOa or #0E               ;
                        OUT (C),C                       ;
                        LD BC,PIOc or #C0               ;
                        OUT (C),C                       ;
                        OUT (C),A                       ;
                        LD BC,PIOk or #92               ;
                        OUT (C),C                       ;
                        RET                             ;
;
StartTone               LD A,B                          ; Never called...
                        LD (nvA),A                      ;
                        LD A,C                          ;
                        LD (nvC),A                      ;
                        LD (nfA),HL                     ;
                        INC HL                          ;
                        LD (nfC),HL                     ;
                        LD A,#B8                        ;
                        LD (nEnables),A                 ;
                        ;
SetSoundD               ld a,1                          ;
                        ld (SDF),a                      ;
                        RET                             ;
;
OutSound                LD BC,PIOk or #82               ;
                        OUT (C),C                       ;
                        LD E,0                          ;
                        LD HL,nfA                       ;
OSlp                    LD B,PIOa / 256                 ;
                        OUT (C),E                       ;
                        LD BC,PIOc or #C0               ;
                        OUT (C),C                       ;
                        XOR A                           ;
                        OUT (C),A                       ;
                        LD B,PIOa / 256                 ;
                        LD A,(HL)                       ;
                        OUT (C),A                       ;
                        XOR A                           ;
                        LD BC,PIOc or #80               ;
                        OUT (C),C                       ;
                        OUT (C),A                       ;
                        INC E                           ;
                        INC HL                          ;
                        LD A,E                          ;
                        CP 13                           ;
                        JR NZ OSlp                      ;
SubSetUpKeys            XOR A                           ;
                        LD BC,PIOa or #0E               ;
                        OUT (C),C                       ;
                        LD BC,PIOc or #C0               ;
                        OUT (C),C                       ;
                        OUT (C),A                       ;
                        LD BC,PIOk or #92               ;
                        OUT (C),C                       ;
                        RET                             ;
;
SDshutup                XOR A                           ;
                        LD (nvA),A                      ;
                        LD (nvB),A                      ;
                        LD (nvC),A                      ;
                        JP SetSoundD                    ;

SDquiet                 XOR A                           ;
                        LD (nvA),A                      ;
                        LD (nvB),A                      ;
                        LD (nvC),A                      ;
                        JP OutSound                     ;
;
SDinit                  XOR A                           ;
                        LD (cPri),A                     ;
                        LD A,$28                        ;
                        LD (nEnables),A                 ;
                        JP SDshutup                     ;
SDnoise                 CP 8                            ;
                        RET NC                          ;
                        LD L,A                          ;
                        LD H,0                          ;
                        LD A,$10                        ;
                        LD (nvB),A                      ;
                        ADD HL,HL                       ;
                        ADD HL,HL                       ;
                        ADD HL,HL                       ;
                        LD DE,SDTab                     ;
                        ADD HL,DE                       ;
                        LD A,(cPri)                     ;
                        CP (HL)                         ;
                        LD A,(HL)                       ;
                        PUSH AF                         ;
                        INC HL                          ;
                        LD A,(HL)                       ;
                        LD (cTime),A                    ;
                        INC HL                          ;
                        LD E,(HL)                       ;
                        INC HL                          ;
                        LD D,(HL)                       ;
                        INC HL                          ;
                        LD (nEnv),DE                    ;
                        LD A,R                          ;
                        ADD A,(HL)                      ;
                        INC HL                          ;
                        LD D,(HL)                       ;
                        INC HL                          ;
                        LD (nfB),DE                     ;
                        LD A,(HL)                       ;
                        INC HL                          ;
                        LD (nfN),A                      ;
                        LD A,(nEnables)                 ;
                        OR $12                          ;
                        AND (HL)                        ;
                        LD (nEnables),A                 ;
                        POP AF                          ;
                        LD (cPri),A                     ;
                        DI                              ;
                        LD BC,PIOk or $82               ;
                        OUT (C),C                       ;
                        LD BC,PIOa or 13                ;
                        OUT (C),C                       ;
                        LD BC,PIOc or $C0               ;
                        OUT (C),C                       ;
                        XOR A                           ;
                        OUT (C),A                       ;
                        LD BC,PIOa or 9                 ; Env
                        OUT (C),C                       ;
                        LD BC,PIOc or $80               ;
                        OUT (C),C                       ;
                        OUT (C),A                       ;
                        CALL SubSetUpKeys               ;
                        LD A,(AType)                    ;
                        CP 5                            ;
                        JP Z SetSoundD                  ;
                        EI                              ;
                        JP SetSoundD                    ;

SDTab                   DEFB $01                        ;
                        DEFB $0A                        ;

                        DEFW $0514                      ;
                        DEFW $0BB8                      ;
                        DEFB $14                        ;
                        DEFB sdNT                       ;

                        ; Enemy fire

                        DEFB $01                        ;
                        DEFB $0A                        ;
                        DEFW $03E8                      ;
                        DEFW $012C                      ;
                        DEFB $14                        ;
                        DEFB sdN                        ;

                        ; Explosion

                        DEFB $01                        ;
                        DEFB $0A                        ;
                        DEFW $1B58                      ;
                        DEFW $2AF8                      ;
                        DEFB $1F                        ;
                        DEFB sdNT                       ;

                        ; Missile Bounce

                        DEFB $01                        ;
                        DEFB $0A                        ;
                        DEFW $03E8                      ;
                        DEFW $012C                      ;
                        DEFB $10                        ;
                        DEFB sdT                        ;

                        ; Bumping

                        DEFB $01                        ;
                        DEFB $0A                        ;
                        DEFW $0BB8                      ;
                        DEFW $0FA0                      ;
                        DEFB $10                        ;
                        DEFB sdT                        ;

                        ; Expl Bounce

                        DEFB $01                        ;
                        DEFB $0A                        ;
                        DEFW $04B0                      ;
                        DEFW $0BB8                      ;
                        DEFB $10                        ;
                        DEFB sdT                        ;

                        ; ?

                        DEFB $01                        ;
                        DEFB $0A                        ;
                        DEFW $03E8                      ;
                        DEFW $012C                      ;
                        DEFB $10                        ;
                        DEFB sdT                        ;

                        ; ?

                        DEFB $01                        ;
                        DEFB $0A                        ;
                        DEFW $03E8                      ;
                        DEFW $012C                      ;
                        DEFB $10                        ;
                        DEFB sdT                        ;

; Entered with HL = dX/dY? Dunno which way round anmd DE=??

SDtank                  PUSH HL                         ;

                        ; 12-bit frequency

                        ld (nfA),hl                     ; Use speed to desynchronise the "engines"
                        add hl,de                       ;
                        ld (nfC),hl                     ;

                        POP HL                          ;

                        CALL RangeVol                   ; Convert the ranges to volumes in B/C

                        LD A,B                          ;
                        LD (nvA),A                      ;

                        LD A,C                          ;
                        LD (nvC),A                      ;

                        JP SetSoundD                    ;

; Calculate the two volumes depending on range somehow

RangeVol                LD A,H                          ;
                        ADD A,A                         ;
                        CALL Clip31                     ;
                        LD B,A                          ;

                        LD A,L                          ;
                        ADD A,A                         ;
                        CALL Clip31                     ;
                        ADD A,B                         ;

                        ; A = |dx| + |dy| or 0 .. 62

                        RRCA                            ;
                        RRCA                            ;

                        ; 0 .. 15
                        AND $0F                         ;
                        NEG                             ;
                        ADD A,15                        ;

                        ; A = 15 .. 0 decreasing with range

                        SRA A                           ;

                        ; A = 30 .. 0

                        SRA B                           ;
                        SRA B                           ;
                        SRA B                           ;
                        SRA B                           ;

                        ; B = 0 or 1 (|dx|/16)

                        ADD A,B                         ;
                        LD C,A                          ; 31 .. 0 (average+top bit)

                        SUB B                           ;
                        SUB B                           ;

                        LD B,A                          ; 30 .. 0 (average-top bit)
                        RET                             ;

Clip31                  OR A                            ;
                        JP P ClipP                      ;
                        NEG                             ;
ClipP                   CP 31                           ;
                        RET C                           ;
                        LD A,31                         ;
                        RET                             ;


BrightTab               DEFB 20,4,21,28,24,29,12        ;
                        DEFB 5,13,22,6,23,30,0,31       ;
                        DEFB 14,7,15,18,2,19,26,25      ;
                        DEFB 27,10,3,11,11              ;
;
DrawPoint               LD A,(Colour)                   ;
                        SRL E                           ;
                        RLA                             ;
                        LD L,A                          ;
                        LD H,BitTab/256                 ;
                        LD A,(ColourMask)               ;
                        CPL                             ;
                        LD B,A                          ;
                        CPL                             ;
                        AND (HL)                        ;
                        LD C,A                          ;
                        ;
                        LD A,L                          ;
                        OR #06                          ;
                        LD L,A                          ;
                        LD A,(HL)                       ;
                        CPL                             ;
                        OR B                            ;
                        LD B,A                          ;
                        ;
                        LD L,D                          ;
                        LD H,YTable/256                 ;
                        LD A,(HL)                       ;
                        INC H                           ;
                        LD H,(HL)                       ;
                        LD L,A                          ;
                        ;
                        LD D,0                          ;
                        ADD HL,DE                       ;
                        ;
                        LD A,(HL)                       ;
                        AND B                           ;
                        OR C                            ;
                        LD (HL),A                       ;
                        ;
                        LD (SubTempSP),SP               ;
                        LD SP,(pLines)                  ;
                        PUSH HL                         ;
                        LD HL,UDP                       ;
                        PUSH HL                         ;
                        SCF                             ;
                        PUSH AF                         ;
                        LD (pLines),SP                  ;
                        LD SP,(SubTempSP)               ;
                        ;
                        RET                             ;
;
SetUpRot                CP 0                            ; Has this changed?
OldRot                  EQU $-1                         ;
                        RET Z                           ; No, exit

                        LD (OldRot),A                   ;

                        CALL Sine                       ; Build the sin multiply
                        LD HL,RMulSin                   ;
                        CALL GenMult                    ;

                        LD A,(OldRot)                   ; Build the cos multiply
                        CALL Cosine                     ;
                        LD HL,RMulCos                   ;
                        JP GenMult                      ;

SetUpRotA               CP 0                            ; Has this changed?
OldRotA                 EQU $-1                         ;
                        RET Z                           ;

                        LD (OldRotA),A                  ;

                        CALL Sine                       ;
                        LD HL,RMulSinA                  ;
                        CALL GenMult                    ;

                        LD A,(OldRotA)                  ;
                        CALL Cosine                     ;
                        LD HL,RMulCosA                  ;

                        ; Fall into

GenMult                 LD A,B                          ;
                        OR A                            ;
                        JR Z GMx                        ;
                        ;
                        DEC A                           ;
                        JR Z GM0                        ;
                        INC A                           ;
                        ;
                        LD (HL),#EB                     ;
                        INC HL                          ;
                        LD (HL),#21                     ;
                        INC HL                          ;
                        LD (HL),#00                     ;
                        INC HL                          ;
                        LD (HL),#00                     ;
                        INC HL                          ;
                        LD (HL),#45                     ;
                        INC HL                          ;
                        LD (HL),#7D                     ;
                        INC HL                          ;
                        ;
                        LD B,8                          ;
                        RES 1,C                         ;
                        ;
GMlp                    RLA                             ;
                        JR NC GMa                       ;
                        ;
                        LD (HL),#19                     ;
                        INC HL                          ;
                        LD (HL),#88                     ;
                        INC HL                          ;
                        ;
                        SET 1,C                         ;
                        ;
GMa                     BIT 1,C                         ;
                        JR Z GMb                        ;
                        ;
                        LD (HL),#29                     ;
                        INC HL                          ;
                        LD (HL),#17                     ;
                        INC HL                          ;
                        ;
GMb                     DJNZ GMlp                       ;
                        ;
                        DEC HL                          ;
                        DEC HL                          ;
                        ;
                        LD (HL),#6C                     ;
                        INC HL                          ;
                        LD (HL),#67                     ;
                        INC HL                          ;
                        ;
GMx                     LD (HL),#C9                     ; Exit
                        ;
                        BIT 0,C                         ;
                        RET Z                           ;
                        ;
                        EX DE,HL                        ;
                        LD HL,NegHL                     ;
                        LD BC,8                         ;
                        LDIR                            ;
                        RET                             ;
;
GM0                     LD (HL),#21                     ; Multiply by zero
                        INC HL                          ;
                        LD (HL),A                       ;
                        INC HL                          ;
                        LD (HL),A                       ;
                        INC HL                          ;
                        LD (HL),#C9                     ;
                        RET                             ;
;
DoRotHLDE               LD (Rtx),HL                     ;
                        LD (Rtz),DE                     ;
                        CALL RMCos                      ;
                        PUSH HL                         ;
                        LD HL,0                         ;
Rtz                     EQU $-2                         ;
                        CALL RMSin                      ;
                        PUSH HL                         ;
                        LD HL,0                         ;
Rtx                     EQU $-2                         ;
                        CALL RMSin                      ;
                        PUSH HL                         ;
                        LD HL,(Rtz)                     ;
                        CALL RMCos                      ;
                        POP DE                          ;
                        OR A                            ;
                        SBC HL,DE                       ;
                        EX DE,HL                        ;
                        POP HL                          ;
                        POP BC                          ;
                        ADD HL,BC                       ;
                        RET                             ;
;
RMCos                   BIT 7,H                         ;
                        JR NZ RMCn                      ;
                        ;
                        JP RMulCos                      ;
;
RMCn                    LD A,L                          ;
                        CPL                             ;
                        LD L,A                          ;
                        LD A,H                          ;
                        CPL                             ;
                        LD H,A                          ;
                        INC HL                          ;
                        ;
                        CALL RMulCos                    ;
                        ;
                        LD A,L                          ;
                        CPL                             ;
                        LD L,A                          ;
                        LD A,H                          ;
                        CPL                             ;
                        LD H,A                          ;
                        INC HL                          ;
                        RET                             ;
;
RMSin                   BIT 7,H                         ;
                        JR NZ RMSn                      ;
                        ;
                        JP RMulSin                      ;
;
RMSn                    LD A,L                          ;
                        CPL                             ;
                        LD L,A                          ;
                        LD A,H                          ;
                        CPL                             ;
                        LD H,A                          ;
                        INC HL                          ;
                        ;
                        CALL RMulSin                    ;
                        ;
                        LD A,L                          ;
                        CPL                             ;
                        LD L,A                          ;
                        LD A,H                          ;
                        CPL                             ;
                        LD H,A                          ;
                        INC HL                          ;
                        RET                             ;
;
DoRotHLDEA              LD (RtxA),HL                    ;
                        LD (RtzA),DE                    ;
                        CALL RMCosA                     ;
                        PUSH HL                         ;
                        LD HL,0                         ;
RtzA                    EQU $-2                         ;
                        CALL RMSinA                     ;
                        PUSH HL                         ;
                        LD HL,0                         ;
RtxA                    EQU $-2                         ;
                        CALL RMSinA                     ;
                        PUSH HL                         ;
                        LD HL,(RtzA)                    ;
                        CALL RMCosA                     ;
                        POP DE                          ;
                        OR A                            ;
                        SBC HL,DE                       ;
                        EX DE,HL                        ;
                        POP HL                          ;
                        POP BC                          ;
                        ADD HL,BC                       ;
                        RET                             ;
;
RMCosA                  BIT 7,H                         ;
                        JR NZ RMCnA                     ;
                        ;
                        JP RMulCosA                     ;
;
RMCnA                   LD A,L                          ;
                        CPL                             ;
                        LD L,A                          ;
                        LD A,H                          ;
                        CPL                             ;
                        LD H,A                          ;
                        INC HL                          ;
                        ;
                        CALL RMulCosA                   ;
                        ;
                        LD A,L                          ;
                        CPL                             ;
                        LD L,A                          ;
                        LD A,H                          ;
                        CPL                             ;
                        LD H,A                          ;
                        INC HL                          ;
                        RET                             ;
;
RMSinA                  BIT 7,H                         ;
                        JR NZ RMSnA                     ;
                        ;
                        JP RMulSinA                     ;
;
RMSnA                   LD A,L                          ;
                        CPL                             ;
                        LD L,A                          ;
                        LD A,H                          ;
                        CPL                             ;
                        LD H,A                          ;
                        INC HL                          ;
                        ;
                        CALL RMulSinA                   ;
                        ;
                        LD A,L                          ;
                        CPL                             ;
                        LD L,A                          ;
                        LD A,H                          ;
                        CPL                             ;
                        LD H,A                          ;
                        INC HL                          ;
                        RET                             ;
;
UnDrawLines             LD (SubTempSP),SP               ;
                        LD SP,(pOLines)                 ;
                        LD HL,(pLines)                  ;
                        LD (pOLines),HL                 ;
                        ;
                        LD A,(ColourMask)               ;
                        BIT 0,A                         ;
                        LD HL,OldLines2                 ;
                        JR NZ UDLa                      ;
                        LD HL,OldLines1                 ;
UDLa                    LD (pLines),HL                  ;
                        ;
UDLret                  POP AF                          ;
                        RET C                           ;
                        ;
                        PUSH AF                         ;
                        LD A,(ColourMask)               ;
                        CPL                             ;
                        LD (ColourMask),A               ;
                        LD SP,(SubTempSP)               ;
                        RET                             ;
;
UDP                     POP HL                          ;
                        LD A,(ColourMask)               ;
                        AND (HL)                        ;
                        LD (HL),A                       ;
                        JP UDLret                       ;
;
HLO                     POP HL                          ;
                        LD B,A                          ;
                        INC B                           ;
                        ;
                        LD A,(ColourMask)               ;
                        LD C,A                          ;
HLOlp                   LD A,(HL)                       ;
                        AND C                           ;
                        LD (HL),A                       ;
                        INC HL                          ;
                        DJNZ HLOlp                      ;
                        JP UDLret                       ;
;
;
CLS                     LD HL,#C000                     ;
                        LD DE,#C001                     ;
                        LD BC,#3FFF                     ;
                        LD (HL),0                       ;
                        LDIR                            ;
                        RET                             ;
;
SetUpTabs               LD IY,SquareTab1                ;
                        LD IX,-#80                      ;
                        CALL SUT0                       ;
                        LD IX,-#40                      ;
SUT0                    XOR A                           ;
SUTl                    PUSH IX                         ;
                        POP DE                          ;
                        LD HL, #00                      ; X
                        PUSH AF                         ;
                        CALL RotHLDEA                   ;
                        POP AF                          ;
                        INC A                           ;
                        LD (IY),L                       ;
                        INC IY                          ;
                        LD (IY),H                       ;
                        INC IY                          ;
                        LD (IY),E                       ;
                        INC IY                          ;
                        LD (IY),D                       ;
                        INC IY                          ;
                        BIT 6,A                         ;
                        JR Z SUTl                       ;
                        RET                             ;
;
CallHL3                 JP (HL)                         ;
;
DoPyra1                 LD HL,#A0                       ;
                        JP DoPyra2                      ;
DoPyra                  LD HL,0                         ;
DoPyra2                 LD DE,(CentY)                   ;
                        ADD HL,DE                       ;
                        LD DE,(CentZ)                   ;
                        CALL ObjeDiv                    ;
                        LD (yv5),HL                     ;
                        LD (yv6),HL                     ;
                        LD (yv7),HL                     ;
                        LD (yv8),HL                     ;
                        ;
                        LD H,SquareTab1/256             ;
                        CALL DoSqBase                   ;
                        ;
                        LD A,1                          ;
                        LD (DrawBaseF),A                ;
                        ;
                        LD HL,(CentX)                   ;
                        LD DE,(CentZ)                   ;
                        CALL ObjeDiv                    ;
                        LD (xv5),HL                     ;
                        LD (xv6),HL                     ;
                        LD (xv7),HL                     ;
                        LD (xv8),HL                     ;
                        ;
Pyramid                 CALL DPlhs                      ;
                        CALL DPrhs                      ;
                        ;
                        LD HL,(yv1)                     ;
                        LD DE,(yv5)                     ;
                        EXX                             ;
                        LD HL,(xv1)                     ;
                        LD DE,(xv5)                     ;
                        CALL AnyLine                    ;
                        ;
                        LD HL,(yv2)                     ;
                        LD DE,(yv6)                     ;
                        EXX                             ;
                        LD HL,(xv2)                     ;
                        LD DE,(xv6)                     ;
                        CALL AnyLine                    ;
                        ;
                        LD HL,(yv2)                     ;
                        LD DE,(yv1)                     ;
                        EXX                             ;
                        LD HL,(xv2)                     ;
                        LD DE,(xv1)                     ;
                        LD A,(DrawBaseF)                ;
                        OR A                            ;
                        CALL NZ AnyLine                 ;
                        ;
                        RET                             ;
                        ;
DPlhs                   LD HL,(xv4)                     ;
                        LD DE,(xv1)                     ;
                        OR A                            ;
                        SBC HL,DE                       ;
                        BIT 7,H                         ;
                        JR NZ DPlhsa                    ;
                        LD A,(CentZ+1)                  ;
                        CP 5                            ;
                        RET NC                          ;
                        LD HL,(xv5)                     ; 0
                        LD DE,(xv1)                     ;
                        OR A                            ;
                        SBC HL,DE                       ;
                        RET Z                           ;
                        PUSH HL                         ;
                        LD HL,(yv5)                     ; 0
                        LD DE,(yv1)                     ;
                        OR A                            ;
                        SBC HL,DE                       ;
                        POP DE                          ;
                        RET Z                           ;
                        CALL SignDiv                    ;
                        PUSH HL                         ;
                        LD HL,(xv4)                     ;
                        LD DE,(xv1)                     ;
                        OR A                            ;
                        SBC HL,DE                       ;
;            JR Z Exit1
                        PUSH HL                         ;
                        LD HL,(yv4)                     ;
                        LD DE,(yv1)                     ;
                        OR A                            ;
                        SBC HL,DE                       ;
                        POP DE                          ;
;            JR Z Exit1
                        CALL SignDiv                    ;
                        EX DE,HL                        ;
                        POP HL                          ;
                        OR A                            ;
                        SBC HL,DE                       ;
                        RET NC                          ;
                        ;
DPlhsa                  LD HL,(yv4)                     ;
                        LD DE,(yv1)                     ;
                        EXX                             ;
                        LD HL,(xv4)                     ;
                        LD DE,(xv1)                     ;
                        LD A,(DrawBaseF)                ;
                        OR A                            ;
                        CALL NZ AnyLine                 ;
                        ;
                        LD HL,(yv4)                     ;
                        LD DE,(yv8)                     ;
                        EXX                             ;
                        LD HL,(xv4)                     ;
                        LD DE,(xv8)                     ;
                        CALL AnyLine                    ;
                        ;
                        RET                             ;
                        ;
Exit1                   POP AF                          ;
                        RET                             ;
                        ;
DPrhs                   LD HL,(xv2)                     ;
                        DEC HL                          ;
                        LD DE,(xv3)                     ;
                        OR A                            ;
                        SBC HL,DE                       ;
                        BIT 7,H                         ;
                        JR NZ DPrhsa                    ;
                        ;
                        LD A,(CentZ+1)                  ;
                        CP 5                            ;
                        RET NC                          ;
                        LD HL,(xv6)                     ; 0
                        LD DE,(xv2)                     ;
                        OR A                            ;
                        SBC HL,DE                       ;
                        RET Z                           ;
                        PUSH HL                         ;
                        LD HL,(yv6)                     ; 0
                        LD DE,(yv2)                     ;
                        OR A                            ;
                        SBC HL,DE                       ;
                        POP DE                          ;
                        RET Z                           ;
                        CALL SignDiv                    ;
                        PUSH HL                         ;
                        LD HL,(xv3)                     ;
                        LD DE,(xv2)                     ;
                        OR A                            ;
                        SBC HL,DE                       ;
;                        JR Z Exit1                      ;
                        PUSH HL                         ;
                        LD HL,(yv3)                     ;
                        LD DE,(yv2)                     ;
                        OR A                            ;
                        SBC HL,DE                       ;
                        POP DE                          ;
;                        JR Z Exit1                      ;
                        CALL SignDiv                    ;
                        EX DE,HL                        ;
                        POP HL                          ;
                        OR A                            ;
                        SBC HL,DE                       ;
                        RET C                           ;
DPrhsa                  LD HL,(yv3)                     ;
                        LD DE,(yv2)                     ;
                        EXX                             ;
                        LD HL,(xv3)                     ;
                        LD DE,(xv2)                     ;
                        LD A,(DrawBaseF)                ;
                        OR A                            ;
                        CALL NZ AnyLine                 ;
                        ;
                        LD HL,(yv3)                     ;
                        LD DE,(yv7)                     ;
                        EXX                             ;
                        LD HL,(xv3)                     ;
                        LD DE,(xv7)                     ;
                        CALL AnyLine                    ;
                        ;
                        RET                             ;
;
DoCube                  LD HL,#30                       ;
                        JP DoCube2                      ;
;
DoCube1                 LD HL,#A0                       ;
DoCube2                 LD DE,(CentY)                   ;
                        ADD HL,DE                       ;
                        LD (CubeY),HL                   ;
                        ;
                        LD H,SquareTab1/256             ;
                        CALL DoSqBase                   ;
                        ;
                        LD HL,0                         ;
CubeY                   EQU $-2                         ;
                        LD DE,(zn1)                     ;
                        CALL ObjeDiv                    ;
                        LD (yv5),HL                     ;
                        ;
                        LD HL,(CubeY)                   ;
                        LD DE,(zn2)                     ;
                        CALL ObjeDiv                    ;
                        LD (yv6),HL                     ;
                        ;
                        LD HL,(CubeY)                   ;
                        LD DE,(zn3)                     ;
                        CALL ObjeDiv                    ;
                        LD (yv7),HL                     ;
                        ;
                        LD HL,(CubeY)                   ;
                        LD DE,(zn4)                     ;
                        CALL ObjeDiv                    ;
                        LD (yv8),HL                     ;
                        ;
                        CALL DClhs                      ;
                        CALL DCrhs                      ;
                        ;
                        LD HL,(yv1)                     ;
                        LD DE,(yv5)                     ;
                        EXX                             ;
                        LD HL,(xv1)                     ;
                        LD DE,(xv1)                     ;
                        CALL AnyLine                    ;
                        ;
                        LD HL,(yv2)                     ;
                        LD DE,(yv6)                     ;
                        EXX                             ;
                        LD HL,(xv2)                     ;
                        LD DE,(xv2)                     ;
                        CALL AnyLine                    ;
                        ;
                        LD HL,(yv2)                     ;
                        LD DE,(yv1)                     ;
                        EXX                             ;
                        LD HL,(xv2)                     ;
                        LD DE,(xv1)                     ;
                        CALL AnyLine                    ;
                        ;
                        LD HL,(yv6)                     ;
                        LD DE,(yv5)                     ;
                        EXX                             ;
                        LD HL,(xv2)                     ;
                        LD DE,(xv1)                     ;
                        CALL AnyLine                    ;
                        ;
                        RET                             ;
                        ;
DClhs                   LD HL,(xv4)                     ;
                        LD DE,(xv1)                     ;
                        OR A                            ;
                        SBC HL,DE                       ;
                        BIT 7,H                         ;
                        RET Z                           ;
                        ;
DClhsa                  LD HL,(yv4)                     ;
                        LD DE,(yv1)                     ;
                        EXX                             ;
                        LD HL,(xv4)                     ;
                        LD DE,(xv1)                     ;
                        CALL AnyLine                    ;
                        ;
                        LD HL,(yv4)                     ;
                        LD DE,(yv8)                     ;
                        EXX                             ;
                        LD HL,(xv4)                     ;
                        LD DE,(xv4)                     ;
                        CALL AnyLine                    ;
                        ;
                        LD HL,(yv8)                     ;
                        LD DE,(yv5)                     ;
                        EXX                             ;
                        LD HL,(xv4)                     ;
                        LD DE,(xv1)                     ;
                        CALL AnyLine                    ;
                        ;
                        RET                             ;
                        ;
DCrhs                   LD HL,(xv2)                     ;
                        DEC HL                          ;
                        LD DE,(xv3)                     ;
                        OR A                            ;
                        SBC HL,DE                       ;
                        BIT 7,H                         ;
                        RET Z                           ;
                        ;
DCrhsa                  LD HL,(yv3)                     ;
                        LD DE,(yv2)                     ;
                        EXX                             ;
                        LD HL,(xv3)                     ;
                        LD DE,(xv2)                     ;
                        CALL AnyLine                    ;
                        ;
                        LD HL,(yv3)                     ;
                        LD DE,(yv7)                     ;
                        EXX                             ;
                        LD HL,(xv3)                     ;
                        LD DE,(xv3)                     ;
                        CALL AnyLine                    ;
                        ;
                        LD HL,(yv7)                     ;
                        LD DE,(yv6)                     ;
                        EXX                             ;
                        LD HL,(xv3)                     ;
                        LD DE,(xv2)                     ;
                        CALL AnyLine                    ;
                        ;
                        RET                             ;
;
DoSqBase                LD A,(DispAng)                  ;
                        ADD A,A                         ;
                        ADD A,A                         ;
                        LD L,A                          ;
                        LD E,(HL)                       ;
                        INC L                           ;
                        LD D,(HL)                       ;
                        INC L                           ;
                        LD (xd1),DE                     ;
                        LD (zd2),DE                     ;
                        LD A,D                          ;
                        CPL                             ;
                        LD D,A                          ;
                        LD A,E                          ;
                        CPL                             ;
                        LD E,A                          ;
                        INC DE                          ;
                        LD (xd3),DE                     ;
                        LD (zd4),DE                     ;
                        ;
                        LD E,(HL)                       ;
                        INC L                           ;
                        LD D,(HL)                       ;
                        LD (zd1),DE                     ;
                        LD (xd4),DE                     ;
                        LD A,D                          ;
                        CPL                             ;
                        LD D,A                          ;
                        LD A,E                          ;
                        CPL                             ;
                        LD E,A                          ;
                        INC DE                          ;
                        LD (zd3),DE                     ;
                        LD (xd2),DE                     ;
                        ;
                        LD DE,(CentX)                   ;
                        LD HL,(xd1)                     ;
                        ADD HL,DE                       ;
                        LD (xn1),HL                     ;
                        LD HL,(xd2)                     ;
                        ADD HL,DE                       ;
                        LD (xn2),HL                     ;
                        LD HL,(xd3)                     ;
                        ADD HL,DE                       ;
                        LD (xn3),HL                     ;
                        LD HL,(xd4)                     ;
                        ADD HL,DE                       ;
                        LD (xn4),HL                     ;
                        ;
                        LD DE,(CentZ)                   ;
                        LD HL,(zd1)                     ;
                        ADD HL,DE                       ;
                        LD (zn1),HL                     ;
                        LD HL,(zd2)                     ;
                        ADD HL,DE                       ;
                        LD (zn2),HL                     ;
                        LD HL,(zd3)                     ;
                        ADD HL,DE                       ;
                        LD (zn3),HL                     ;
                        LD HL,(zd4)                     ;
                        ADD HL,DE                       ;
                        LD (zn4),HL                     ;
                        ;
                        LD HL,(xn1)                     ;
                        LD DE,(zn1)                     ;
                        CALL ObjeDiv                    ;
                        LD (xv1),HL                     ;
                        LD HL,(xn2)                     ;
                        LD DE,(zn2)                     ;
                        CALL ObjeDiv                    ;
                        LD (xv2),HL                     ;
                        LD HL,(xn3)                     ;
                        LD DE,(zn3)                     ;
                        CALL ObjeDiv                    ;
                        LD (xv3),HL                     ;
                        LD HL,(xn4)                     ;
                        LD DE,(zn4)                     ;
                        CALL ObjeDiv                    ;
                        LD (xv4),HL                     ;
                        ;
                        LD HL,Floor                     ;
                        LD DE,(CentY)                   ;
                        ADD HL,DE                       ;
                        LD DE,(zn1)                     ;
                        CALL ObjeDiv                    ;
                        LD (yv1),HL                     ;
                        ;
                        LD HL,Floor                     ;
                        LD DE,(CentY)                   ;
                        ADD HL,DE                       ;
                        LD DE,(zn2)                     ;
                        CALL ObjeDiv                    ;
                        LD (yv2),HL                     ;
                        ;
                        LD HL,Floor                     ;
                        LD DE,(CentY)                   ;
                        ADD HL,DE                       ;
                        LD DE,(zn3)                     ;
                        CALL ObjeDiv                    ;
                        LD (yv3),HL                     ;
                        ;
                        LD HL,Floor                     ;
                        LD DE,(CentY)                   ;
                        ADD HL,DE                       ;
                        LD DE,(zn4)                     ;
                        CALL ObjeDiv                    ;
                        LD (yv4),HL                     ;
                        RET                             ;
                        ;
DoFuel                  LD H,SquareTab1/256             ;
                        JP DoSqu                        ;
DoSauc                  LD H,SquareTab2/256             ;
DoSqu                   CALL DoSqBase                   ;
                        ;
                        LD HL,(yv1)                     ;
                        LD DE,(yv2)                     ;
                        EXX                             ;
                        LD HL,(xv1)                     ;
                        LD DE,(xv2)                     ;
                        CALL AnyLine                    ;
                        ;
                        LD HL,(yv2)                     ;
                        LD DE,(yv3)                     ;
                        EXX                             ;
                        LD HL,(xv2)                     ;
                        LD DE,(xv3)                     ;
                        CALL AnyLine                    ;
                        ;
                        LD HL,(yv3)                     ;
                        LD DE,(yv4)                     ;
                        EXX                             ;
                        LD HL,(xv3)                     ;
                        LD DE,(xv4)                     ;
                        CALL AnyLine                    ;
                        ;
                        LD HL,(yv4)                     ;
                        LD DE,(yv1)                     ;
                        EXX                             ;
                        LD HL,(xv4)                     ;
                        LD DE,(xv1)                     ;
                        CALL AnyLine                    ;
                        ;
                        RET                             ;
;
DoTank                  LD A,(DispAng)                  ;
                        ADD A,#80                       ;
                        CALL SetUpRotA                  ;
                        LD A,1                          ;
                        LD (DrawBaseF),A                ;
                        LD HL,(CentY)                   ;
                        PUSH IX                         ;
                        PUSH IY                         ;
                        LD B,4                          ;
                        LD DE,Floor                     ;
                        ADD HL,DE                       ;
                        LD (cY),HL                      ;
                        LD IX,TBPa                      ;
                        LD IY,Points                    ;
SORlp                   PUSH BC                         ;
                        CALL GenPt                      ;
                        LD BC,4                         ;
                        ADD IY,BC                       ;
                        ADD IX,BC                       ;
                        POP BC                          ;
                        DJNZ SORlp                      ;
                        ;
                        LD B,4                          ;
                        LD DE,-#28                      ;
                        LD HL,(CentY)                   ;
                        ADD HL,DE                       ;
                        LD (cY),HL                      ;
SORlp1                  PUSH BC                         ;
                        CALL GenPt                      ;
                        LD BC,4                         ;
                        ADD IY,BC                       ;
                        ADD IX,BC                       ;
                        POP BC                          ;
                        DJNZ SORlp1                     ;
                        ;
                        LD B,4                          ;
                        LD DE,#28                       ;
                        LD HL,(CentY)                   ;
                        ADD HL,DE                       ;
                        LD (cY),HL                      ;
SORlp2                  PUSH BC                         ;
                        CALL GenPt                      ;
                        LD BC,4                         ;
                        ADD IY,BC                       ;
                        ADD IX,BC                       ;
                        POP BC                          ;
                        DJNZ SORlp2                     ;
                        ;
                        LD IY,Points+#30                ;
                        ;
                        LD B,4                          ;
                        LD DE,-#D                       ;
                        LD HL,(CentY)                   ;
                        ADD HL,DE                       ;
                        LD (cY),HL                      ;
SORlp3                  PUSH BC                         ;
                        CALL GenPt                      ;
                        LD BC,4                         ;
                        ADD IY,BC                       ;
                        ADD IX,BC                       ;
                        POP BC                          ;
                        DJNZ SORlp3                     ;
                        ;
                        LD B,4                          ;
                        LD DE,#D                        ;
                        LD HL,(CentY)                   ;
                        ADD HL,DE                       ;
                        LD (cY),HL                      ;
SORlp4                  PUSH BC                         ;
                        CALL GenPt                      ;
                        LD BC,4                         ;
                        ADD IY,BC                       ;
                        ADD IX,BC                       ;
                        POP BC                          ;
                        DJNZ SORlp4                     ;
                        ;
                        POP IY                          ;
                        ;
                        LD IX,Points                    ;
                        LD A,(DispAng)                  ;
                        ADD A,32+#80                    ;
                        RLCA                            ;
                        RLCA                            ;
                        RLCA                            ;
                        RLCA                            ;
                        AND #0C                         ;
                        LD IXL,A                        ;
                        ;
                        LD L,(IX):LD H,(IX+1)           ;
                        LD (xv1),HL                     ;
                        LD L,(IX+16):LD H,(IX+17)       ;
                        LD (xv5),HL                     ;
                        LD L,(IX+32):LD H,(IX+33)       ;
                        LD (xv9),HL                     ;
                        INC IX:INC IX                   ;
                        LD L,(IX):LD H,(IX+1)           ;
                        LD (yv1),HL                     ;
                        LD L,(IX+16):LD H,(IX+17)       ;
                        LD (yv5),HL                     ;
                        LD L,(IX+32):LD H,(IX+33)       ;
                        LD (yv9),HL                     ;
                        INC IX:INC IX                   ;
                        LD A,IXL                        ;
                        AND #F                          ;
                        LD IXL,A                        ;
                        ;
                        LD L,(IX):LD H,(IX+1)           ;
                        LD (xv2),HL                     ;
                        LD L,(IX+16):LD H,(IX+17)       ;
                        LD (xv6),HL                     ;
                        LD L,(IX+32):LD H,(IX+33)       ;
                        LD (xvA),HL                     ;
                        INC IX:INC IX                   ;
                        LD L,(IX):LD H,(IX+1)           ;
                        LD (yv2),HL                     ;
                        LD L,(IX+16):LD H,(IX+17)       ;
                        LD (yv6),HL                     ;
                        LD L,(IX+32):LD H,(IX+33)       ;
                        LD (yvA),HL                     ;
                        INC IX:INC IX                   ;
                        LD A,IXL                        ;
                        AND #0F                         ;
                        LD IXL,A                        ;
                        ;
                        LD L,(IX):LD H,(IX+1)           ;
                        LD (xv3),HL                     ;
                        LD L,(IX+16):LD H,(IX+17)       ;
                        LD (xv7),HL                     ;
                        LD L,(IX+32):LD H,(IX+33)       ;
                        LD (xvB),HL                     ;
                        INC IX:INC IX                   ;
                        LD L,(IX):LD H,(IX+1)           ;
                        LD (yv3),HL                     ;
                        LD L,(IX+16):LD H,(IX+17)       ;
                        LD (yv7),HL                     ;
                        LD L,(IX+32):LD H,(IX+33)       ;
                        LD (yvB),HL                     ;
                        INC IX:INC IX                   ;
                        LD A,IXL                        ;
                        AND #0F                         ;
                        LD IXL,A                        ;
                        ;
                        LD L,(IX):LD H,(IX+1)           ;
                        LD (xv4),HL                     ;
                        LD L,(IX+16):LD H,(IX+17)       ;
                        LD (xv8),HL                     ;
                        LD L,(IX+32):LD H,(IX+33)       ;
                        LD (xvC),HL                     ;
                        INC IX:INC IX                   ;
                        LD L,(IX):LD H,(IX+1)           ;
                        LD (yv4),HL                     ;
                        LD L,(IX+16):LD H,(IX+17)       ;
                        LD (yv8),HL                     ;
                        LD L,(IX+32):LD H,(IX+33)       ;
                        LD (yvC),HL                     ;
                        ;
                        CALL Pyramid                    ;
                        ;
                        LD HL,xv5                       ;
                        LD DE,xv1                       ;
                        LD BC,8*4                       ;
                        LDIR                            ;
                        XOR A                           ;
                        LD (DrawBaseF),A                ;
                        ;
                        CALL Pyramid                    ;
                        ;
                        LD HL,(Points+34)               ;
                        LD DE,(Points+38)               ;
                        EXX                             ;
                        LD HL,(Points+32)               ;
                        LD DE,(Points+36)               ;
                        CALL AnyLine                    ;
                        ;
                        POP IX                          ;
                        ;
                        LD A,(DispAng)                  ;
                        BIT 7,A                         ;
                        JP NZ BarRHV                    ;
                        ;
                        LD DE,(BarAx)                   ;
                        LD A,(DispAng)                  ;
                        ADD A,20+#80                    ;
                        CP 40                           ;
                        JR C Barlp                      ;
                        LD HL,(BarLHS)                  ;
                        OR A                            ;
                        SBC HL,DE                       ;
                        BIT 7,H                         ;
                        RET Z                           ;
                        ;
Barlp                   LD HL,(BarBx)                   ;
                        INC DE                          ;
                        OR A                            ;
                        SBC HL,DE                       ;
                        BIT 7,H                         ;
                        CALL Z BarFront                 ;
                        JR Z Blhvb                      ;
                        ;
                        LD HL,(BarAy)                   ;
                        LD DE,(BarAy1)                  ;
                        EXX                             ;
                        LD HL,(BarAx)                   ;
                        LD DE,(BarAx)                   ;
                        CALL AnyLine                    ;
                        ;
Blhvb                   LD HL,(BarCx)                   ;
                        LD DE,(BarLHS)                  ;
                        OR A                            ;
                        SBC HL,DE                       ;
                        BIT 7,H                         ;
                        JR Z Blhva                      ;
                        ;
                        LD (BarCx),DE                   ;
                        LD (BarDx),DE                   ;
                        LD HL,(BarAy)                   ;
                        LD (BarCy),HL                   ;
                        LD HL,(BarAy1)                  ;
                        LD (BarCy1),HL                  ;
                        ;
Blhva                   LD HL,(BarAy)                   ;
                        LD DE,(BarCy)                   ;
                        EXX                             ;
                        LD HL,(BarAx)                   ;
                        LD DE,(BarCx)                   ;
                        CALL AnyLine                    ;
                        ;
                        LD HL,(BarAy1)                  ;
                        LD DE,(BarCy1)                  ;
                        EXX                             ;
                        LD HL,(BarAx)                   ;
                        LD DE,(BarCx)                   ;
                        CALL AnyLine                    ;
                        ;
                        LD HL,(BarDx)                   ;
                        LD DE,(BarBx)                   ;
                        OR A                            ;
                        SBC HL,DE                       ;
                        BIT 7,H                         ;
                        RET NZ                          ;
                        ;
                        LD A,(DispAng)                  ;
                        ADD A,50+#80                    ;
                        CP 100                          ;
                        RET NC                          ;
                        ;
                        LD HL,(BarBy)                   ;
                        LD DE,(BarDy)                   ;
                        EXX                             ;
                        LD HL,(BarBx)                   ;
                        LD DE,(BarDx)                   ;
                        CALL AnyLine                    ;
                        ;
                        LD HL,(BarBy1)                  ;
                        LD DE,(BarDy1)                  ;
                        EXX                             ;
                        LD HL,(BarBx)                   ;
                        LD DE,(BarDx)                   ;
                        JP AnyLine                      ;
;
BarRHV                  LD A,(DispAng)                  ;
                        ADD A,20+#80                    ;
                        CP 40                           ;
                        JR C Barrp                      ;
                        LD HL,(BarBx)                   ;
                        LD DE,(BarRHS)                  ;
                        OR A                            ;
                        SBC HL,DE                       ;
                        BIT 7,H                         ;
                        RET Z                           ;
                        ;
Barrp                   LD HL,(BarBx)                   ;
                        LD DE,(BarAx)                   ;
                        INC DE                          ;
                        OR A                            ;
                        SBC HL,DE                       ;
                        BIT 7,H                         ;
                        CALL Z BarFront                 ;
                        JR Z Brhvb                      ;
                        ;
                        LD HL,(BarBy)                   ;
                        LD DE,(BarBy1)                  ;
                        EXX                             ;
                        LD HL,(BarBx)                   ;
                        LD DE,(BarBx)                   ;
                        CALL AnyLine                    ;
                        ;
Brhvb                   LD HL,(BarDx)                   ;
                        LD DE,(BarRHS)                  ;
                        OR A                            ;
                        SBC HL,DE                       ;
                        BIT 7,H                         ;
                        JR NZ Brhva                     ;
                        ;
                        LD (BarCx),DE                   ;
                        LD (BarDx),DE                   ;
                        LD HL,(BarBy)                   ;
                        LD (BarDy),HL                   ;
                        LD HL,(BarBy1)                  ;
                        LD (BarDy1),HL                  ;
                        ;
Brhva                   LD HL,(BarBy)                   ;
                        LD DE,(BarDy)                   ;
                        EXX                             ;
                        LD HL,(BarBx)                   ;
                        LD DE,(BarDx)                   ;
                        CALL AnyLine                    ;
                        ;
                        LD HL,(BarBy1)                  ;
                        LD DE,(BarDy1)                  ;
                        EXX                             ;
                        LD HL,(BarBx)                   ;
                        LD DE,(BarDx)                   ;
                        CALL AnyLine                    ;
                        ;
                        LD HL,(BarAx)                   ;
                        LD DE,(BarCx)                   ;
                        OR A                            ;
                        SBC HL,DE                       ;
                        BIT 7,H                         ;
                        RET NZ                          ;
                        ;
                        LD A,(DispAng)                  ;
                        ADD A,50+#80                    ;
                        CP 100                          ;
                        RET NC                          ;
                        ;
                        LD HL,(BarAy)                   ;
                        LD DE,(BarCy)                   ;
                        EXX                             ;
                        LD HL,(BarAx)                   ;
                        LD DE,(BarCx)                   ;
                        CALL AnyLine                    ;
                        ;
                        LD HL,(BarAy1)                  ;
                        LD DE,(BarCy1)                  ;
                        EXX                             ;
                        LD HL,(BarAx)                   ;
                        LD DE,(BarCx)                   ;
                        JP AnyLine                      ;
;
BarFront                PUSH AF                         ;
                        LD HL,(BarAy)                   ;
                        LD DE,(BarBy)                   ;
                        EXX                             ;
                        LD HL,(BarAx)                   ;
                        LD DE,(BarBx)                   ;
                        CALL AnyLine                    ;
                        ;
                        LD HL,(BarAy1)                  ;
                        LD DE,(BarBy1)                  ;
                        EXX                             ;
                        LD HL,(BarAx)                   ;
                        LD DE,(BarBx)                   ;
                        CALL AnyLine                    ;
                        ;
                        LD HL,(BarAy)                   ;
                        LD DE,(BarAy1)                  ;
                        EXX                             ;
                        LD HL,(BarAx)                   ;
                        LD DE,(BarAx)                   ;
                        CALL AnyLine                    ;
                        ;
                        LD HL,(BarBy)                   ;
                        LD DE,(BarBy1)                  ;
                        EXX                             ;
                        LD HL,(BarBx)                   ;
                        LD DE,(BarBx)                   ;
                        CALL AnyLine                    ;
                        POP AF                          ;
                        RET                             ;
;
DoExp                   LD HL,-SBW-#A0                  ;
                        LD DE,(CentY)                   ;
                        ADD HL,DE                       ;
                        LD (cY),HL                      ;
                        ;
                        PUSH IY                         ;
                        LD IY,Points                    ;
                        LD HL,0                         ;
                        LD DE,0                         ;
                        LD A,(DispAng)                  ;
                        CALL DoPointA                   ;
                        LD BC,4                         ;
                        ADD IY,BC                       ;
                        ;
                        LD HL,(CentY)                   ;
                        LD DE,-#A0                      ;
                        ADD HL,DE                       ;
                        LD (cY),HL                      ;
                        ;
                        LD HL,0                         ;
                        LD DE,SBL                       ;
                        LD A,(DispAng)                  ;
                        CALL DoPointA                   ;
                        LD BC,4                         ;
                        ADD IY,BC                       ;
                        ;
                        LD HL, ExY-#A0                  ;
                        LD DE,(CentY)                   ;
                        ADD HL,DE                       ;
                        LD (cY),HL                      ;
                        ;
                        LD HL,0                         ;
                        LD DE,0                         ;
                        LD A,(DispAng)                  ;
                        CALL DoPointA                   ;
                        ;
                        POP IY                          ;
                        LD HL,(Points)                  ;
                        LD DE,(Points+4)                ;
                        EXX                             ;
                        LD HL,(Points+2)                ;
                        LD DE,(Points+6)                ;
                        EXX                             ;
                        CALL AnyLine                    ;
                        ;
                        LD HL,(Points+4)                ;
                        LD DE,(Points+8)                ;
                        EXX                             ;
                        LD HL,(Points+6)                ;
                        LD DE,(Points+10)               ;
                        EXX                             ;
                        CALL AnyLine                    ;
                        ;
                        LD HL,(Points+8)                ;
                        LD DE,(Points)                  ;
                        EXX                             ;
                        LD HL,(Points+10)               ;
                        LD DE,(Points+2)                ;
                        EXX                             ;
                        JP AnyLine                      ;
;
DoMiss                  LD HL,MBW                       ;
                        LD (vSBW),HL                    ;
                        LD HL,-MBW                      ;
                        LD (vmSBW),HL                   ;
                        LD A,SBS                        ;
                        LD (IgZ),A                      ;
                        LD (IgZ1),A                     ;
                        LD HL,MBL                       ;
                        LD (vSBL),HL                    ;
                        LD A,MBS                        ;
                        LD (IgZ),A                      ;
                        LD (IgZ1),A                     ;
                        JP DoShell1                     ;
;
DoShell                 LD HL,SBW                       ;
                        LD (vSBW),HL                    ;
                        LD HL,-SBW                      ;
                        LD (vmSBW),HL                   ;
                        LD HL,SBL                       ;
                        LD (vSBL),HL                    ;
                        ;
DoShell1                LD A,(DispAng)                  ;
                        CALL SetUpRotA                  ;
                        ;
                        LD HL,-SBW                      ;
vmSBW                   EQU $-2                         ;
                        LD DE,(CentY)                   ;
                        ADD HL,DE                       ;
                        LD (cY),HL                      ;
                        ;
                        PUSH IY                         ;
                        LD IY,Points                    ;
                        LD HL,SBW                       ;
vSBW                    EQU $-2                         ;
                        LD DE,0                         ;
                        CALL DoPoint                    ;
                        LD BC,4                         ;
                        ADD IY,BC                       ;
                        LD HL,-SBW                      ;
                        LD DE,0                         ;
                        CALL DoPoint                    ;
                        LD BC,4                         ;
                        ADD IY,BC                       ;
                        ;
                        LD HL, SBW                      ;
                        LD DE,(CentY)                   ;
                        ADD HL,DE                       ;
                        LD (cY),HL                      ;
                        ;
                        LD HL,(vSBW)                    ;
                        LD DE,0                         ;
                        CALL DoPointY                   ;
                        LD BC,4                         ;
                        ADD IY,BC                       ;
                        LD HL,(vmSBW)                   ;
                        LD DE,0                         ;
                        CALL DoPointY                   ;
                        LD BC,4                         ;
                        ADD IY,BC                       ;
                        ;
                        LD HL,(Points)                  ;
                        LD (Points+8),HL                ;
                        LD HL,(Points+4)                ;
                        LD (Points+12),HL               ;
                        ;
                        LD HL,(CentY)                   ;
                        LD (cY),HL                      ;
                        ;
                        LD HL,0                         ;
                        LD DE,SBL                       ;
vSBL                    EQU $-2                         ;
                        CALL DoPoint                    ;
                        ;
                        POP IY                          ;
                        ;
                        LD A,(DispAng)                  ;
                        OR A                            ;
                        JP M SDneg                      ;
                        ;
                        LD HL,(ShellAx)                 ;
                        LD DE,(ShellBx)                 ;
                        OR A                            ;
                        SBC HL,DE                       ;
                        BIT 7,H                         ;
                        JR Z SNposa                     ;
                        ;
                        CALL ShellBase                  ;
                        ;
                        LD HL,(ShellBx)                 ;
                        LD DE,(ShellCx)                 ;
                        OR A                            ;
                        SBC HL,DE                       ;
                        BIT 7,H                         ;
                        RET Z                           ;
                        ;
                        LD HL,(ShellBy)                 ;
                        LD DE,(ShellCy)                 ;
                        EXX                             ;
                        LD HL,(ShellBx)                 ;
                        LD DE,(ShellCx)                 ;
                        CALL AnyLine                    ;
                        ;
                        LD HL,(ShellBy1)                ;
                        LD DE,(ShellCy)                 ;
                        EXX                             ;
                        LD HL,(ShellBx)                 ;
                        LD DE,(ShellCx)                 ;
                        JP AnyLine                      ;
;
SNposa                  LD HL,(ShellBy)                 ;
                        LD DE,(ShellCy)                 ;
                        EXX                             ;
                        LD HL,(ShellBx)                 ;
                        LD DE,(ShellCx)                 ;
                        CALL AnyLine                    ;
                        ;
                        LD HL,(ShellBy1)                ;
                        LD DE,(ShellCy)                 ;
                        EXX                             ;
                        LD HL,(ShellBx)                 ;
                        LD DE,(ShellCx)                 ;
                        CALL AnyLine                    ;
                        ;
                        LD HL,(ShellBy1)                ;
                        LD DE,(ShellBy)                 ;
                        EXX                             ;
                        LD HL,(ShellBx)                 ;
                        LD DE,(ShellBx)                 ;
                        CALL AnyLine                    ;
                        ;
                        LD HL,(ShellBx)                 ;
                        LD DE,(ShellAx)                 ;
                        OR A                            ;
                        SBC HL,DE                       ;
                        RET Z                           ;
                        ;
                        LD A,(CentZ+1)                  ;
                        CP 18                           ;
IgZ                     EQU $-1                         ;
                        RET NC                          ;
                        ;
                        ;
                        LD HL,(ShellAy)                 ;
                        LD DE,(ShellBy)                 ;
                        EXX                             ;
                        LD HL,(ShellAx)                 ;
                        LD DE,(ShellBx)                 ;
                        CALL AnyLine                    ;
                        ;
                        LD HL,(ShellAy1)                ;
                        LD DE,(ShellBy1)                ;
                        EXX                             ;
                        LD HL,(ShellAx)                 ;
                        LD DE,(ShellBx)                 ;
                        CALL AnyLine                    ;
                        ;
                        LD HL,(ShellAy1)                ;
                        LD DE,(ShellCy)                 ;
                        EXX                             ;
                        LD HL,(ShellAx)                 ;
                        LD DE,(ShellCx)                 ;
                        CALL AnyLine                    ;
                        ;
                        LD HL,(ShellAy)                 ;
                        LD DE,(ShellCy)                 ;
                        EXX                             ;
                        LD HL,(ShellAx)                 ;
                        LD DE,(ShellCx)                 ;
                        CALL AnyLine                    ;
                        ;
                        LD HL,(ShellAx)                 ;
                        LD DE,(ShellCx)                 ;
                        OR A                            ;
                        SBC HL,DE                       ;
                        BIT 7,H                         ;
                        RET NZ                          ;
                        ;
                        LD HL,(ShellAy1)                ;
                        LD DE,(ShellAy)                 ;
                        EXX                             ;
                        LD HL,(ShellAx)                 ;
                        LD DE,(ShellAx)                 ;
                        JP AnyLine                      ;
;
                        RET                             ;
;
SDneg                   LD HL,(ShellAx)                 ;
                        LD DE,(ShellBx)                 ;
                        OR A                            ;
                        SBC HL,DE                       ;
                        BIT 7,H                         ;
                        JR Z SNnega                     ;
                        ;
                        CALL ShellBase                  ;
                        ;
                        LD HL,(ShellAx)                 ; A/B
                        LD DE,(ShellCx)                 ;
                        OR A                            ;
                        SBC HL,DE                       ;
                        BIT 7,H                         ;
                        RET NZ                          ; Z
                        ;
                        LD HL,(ShellAy)                 ; A/B
                        LD DE,(ShellCy)                 ;
                        EXX                             ;
                        LD HL,(ShellAx)                 ; A/B
                        LD DE,(ShellCx)                 ;
                        CALL AnyLine                    ;
                        ;
                        LD HL,(ShellAy1)                ; A/B
                        LD DE,(ShellCy)                 ;
                        EXX                             ;
                        LD HL,(ShellAx)                 ; A/B
                        LD DE,(ShellCx)                 ;
                        JP AnyLine                      ;
;
SNnega                  LD HL,(ShellAy)                 ; A/B
                        LD DE,(ShellCy)                 ;
                        EXX                             ;
                        LD HL,(ShellAx)                 ; A/B
                        LD DE,(ShellCx)                 ;
                        CALL AnyLine                    ;
                        ;
                        LD HL,(ShellAy1)                ; A/B
                        LD DE,(ShellCy)                 ;
                        EXX                             ;
                        LD HL,(ShellAx)                 ; A/B
                        LD DE,(ShellCx)                 ;
                        CALL AnyLine                    ;
                        ;
                        LD HL,(ShellAy1)                ; A/B
                        LD DE,(ShellAy)                 ; A/B
                        EXX                             ;
                        LD HL,(ShellAx)                 ; A/B
                        LD DE,(ShellAx)                 ; A/B
                        CALL AnyLine                    ;
                        ;
                        LD HL,(ShellBx)                 ;
                        LD DE,(ShellAx)                 ;
                        OR A                            ;
                        SBC HL,DE                       ;
                        RET Z                           ;
                        ;
                        LD A,(CentZ+1)                  ;
                        CP 18                           ;
IgZ1                    EQU $-1                         ;
                        RET NC                          ;
                        ;
                        ;
                        LD HL,(ShellAy)                 ;
                        LD DE,(ShellBy)                 ;
                        EXX                             ;
                        LD HL,(ShellAx)                 ;
                        LD DE,(ShellBx)                 ;
                        CALL AnyLine                    ;
                        ;
                        LD HL,(ShellAy1)                ;
                        LD DE,(ShellBy1)                ;
                        EXX                             ;
                        LD HL,(ShellAx)                 ;
                        LD DE,(ShellBx)                 ;
                        CALL AnyLine                    ;
                        ;
                        LD HL,(ShellBy1)                ; B/A
                        LD DE,(ShellCy)                 ;
                        EXX                             ;
                        LD HL,(ShellBx)                 ; B/A
                        LD DE,(ShellCx)                 ;
                        CALL AnyLine                    ;
                        ;
                        LD HL,(ShellBy)                 ; B/A
                        LD DE,(ShellCy)                 ;
                        EXX                             ;
                        LD HL,(ShellBx)                 ; B/A
                        LD DE,(ShellCx)                 ;
                        CALL AnyLine                    ;
                        ;
                        LD HL,(ShellBx)                 ; B/A
                        LD DE,(ShellCx)                 ;
                        OR A                            ;
                        SBC HL,DE                       ;
                        BIT 7,H                         ;
                        RET Z                           ; NZ
                        ;
                        LD HL,(ShellBy1)                ; B/A
                        LD DE,(ShellBy)                 ; B/A
                        EXX                             ;
                        LD HL,(ShellBx)                 ; B/A
                        LD DE,(ShellBx)                 ; B/A
                        JP AnyLine                      ;
;
                        RET                             ;
;
ShellBase               LD HL,(ShellAy1)                ;
                        LD DE,(ShellAy)                 ;
                        EXX                             ;
                        LD HL,(ShellAx)                 ;
                        LD DE,(ShellAx)                 ;
                        CALL AnyLine                    ;
                        ;
                        LD HL,(ShellBy1)                ;
                        LD DE,(ShellBy)                 ;
                        EXX                             ;
                        LD HL,(ShellBx)                 ;
                        LD DE,(ShellBx)                 ;
                        CALL AnyLine                    ;
                        ;
                        LD HL,(ShellAy)                 ;
                        LD DE,(ShellBy)                 ;
                        EXX                             ;
                        LD HL,(ShellAx)                 ;
                        LD DE,(ShellBx)                 ;
                        CALL AnyLine                    ;
                        ;
                        LD HL,(ShellAy1)                ;
                        LD DE,(ShellBy1)                ;
                        EXX                             ;
                        LD HL,(ShellAx)                 ;
                        LD DE,(ShellBx)                 ;
                        JP AnyLine                      ;
;
DoPointA                CALL RotHLDEA                   ;
                        JP DoPa                         ;
                        ;
GenPt                   LD L,(IX+SubptX)                ;
                        LD H,(IX+SubptX+1)              ;
                        LD E,(IX+SubptZ)                ;
                        LD D,(IX+SubptZ+1)              ;
DoPoint                 CALL DoRotHLDEA                 ;
DoPa                    LD BC,(CentX)                   ;
                        ADD HL,BC                       ;
                        EX DE,HL                        ;
                        LD BC,(CentZ)                   ;
                        ADD HL,BC                       ;
                        EX DE,HL                        ;
                        CALL ObjeDiv                    ;
                        LD (IY+PlanX),L                 ;
                        LD (IY+PlanX+1),H               ;
                        ;
                        LD HL,(cY)                      ;
                        CALL ObjeDiv                    ;
                        LD (IY+PlanY),L                 ;
                        LD (IY+PlanY+1),H               ;
                        RET                             ;
;
DoPointY                CALL DoRotHLDEA                 ;
                        LD HL,(CentZ)                   ;
                        ADD HL,DE                       ;
                        EX DE,HL                        ;
                        LD HL,(cY)                      ;
                        CALL ObjeDiv                    ;
                        LD (IY+PlanY),L                 ;
                        LD (IY+PlanY+1),H               ;
                        RET                             ;
;
RotHLDEA                LD (RtXV),HL                    ;
                        LD (RtZV),DE                    ;
                        PUSH AF                         ;
                        CALL Sine                       ;
                        POP AF                          ;
                        LD (RotSin),BC                  ;
                        CALL Cosine                     ;
                        LD (RotCos),BC                  ;
                        CALL Mult8                      ;
                        PUSH HL                         ;
                        LD HL,(RtZV)                    ;
                        LD BC,0                         ;
RotSin                  EQU $-2                         ;
                        CALL Mult8                      ;
                        POP DE                          ;
                        ADD HL,DE                       ;
                        PUSH HL                         ;
                        LD HL,(RtXV)                    ;
                        LD BC,(RotSin)                  ;
                        CALL Mult8                      ;
                        PUSH HL                         ;
                        LD HL,(RtZV)                    ;
                        LD BC,0                         ;
RotCos                  EQU $-2                         ;
                        CALL Mult8                      ;
                        POP DE                          ;
                        OR A                            ;
                        SBC HL,DE                       ;
                        EX DE,HL                        ;
                        POP HL                          ;
                        RET                             ;
;
Rand                    CALL Rand1                      ;
                        LD DE,(Seed)                    ;
                        RET                             ;
                        ;
Rand1                   LD HL,(Seed+2)                  ;
                        RL L                            ;
                        RL H                            ;
                        RL L                            ;
                        RL H                            ;
                        LD C,H                          ;
                        LD A,(Seed)                     ;
                        RLA                             ;
                        LD B,A                          ;
                        LD DE,(Seed+1)                  ;
                        RL E                            ;
                        RL D                            ;
                        RES 7,D                         ;
                        LD HL,(Seed)                    ;
                        ADD HL,BC                       ;
                        LD (Seed),HL                    ;
                        LD HL,(Seed+2)                  ;
                        ADC HL,DE                       ;
                        RES 7,H                         ;
                        LD (Seed+2),HL                  ;
                        RET M                           ;
                        LD HL,Seed                      ;
Rand2                   INC (HL)                        ;
                        RET NZ                          ;
                        INC HL                          ;
                        JR Rand2                        ;
                        ;
Seed                    DEFM "Nig!"                     ;
;
DivHLDE                 LD A,H                          ;
                        CP D                            ;
                        JR Z Div1                       ;
                        JR NC Div16                     ;
Div81                   XOR A                           ;
Div8                    LD C,A                          ;
                        ADD HL,HL                       ;
                        SBC HL,DE                       ;
                        JR C Div70                      ;
                        ADC A,A                         ;
                        ADD HL,HL                       ;
                        SBC HL,DE                       ;
                        JR C Div60                      ;
Div61                   ADC A,A                         ;
                        ADD HL,HL                       ;
                        SBC HL,DE                       ;
                        JR C Div50                      ;
Div51                   ADC A,A                         ;
                        ADD HL,HL                       ;
                        SBC HL,DE                       ;
                        JR C Div40                      ;
Div41                   ADC A,A                         ;
                        ADD HL,HL                       ;
                        SBC HL,DE                       ;
                        JR C Div30                      ;
Div31                   ADC A,A                         ;
                        ADD HL,HL                       ;
                        SBC HL,DE                       ;
                        JR C Div20                      ;
Div21                   ADC A,A                         ;
                        ADD HL,HL                       ;
                        SBC HL,DE                       ;
                        JR C Div10                      ;
Div11                   ADC A,A                         ;
                        ADD HL,HL                       ;
                        SBC HL,DE                       ;
                        ADC A,A                         ;
                        CPL                             ;
                        LD L,A                          ;
                        LD H,C                          ;
                        RET                             ;
Div1                    LD A,L                          ;
                        CP E                            ;
                        JR C Div81                      ;
                        JR Z Div0                       ;
Div16                   LD A,L                          ;
                        LD L,H                          ;
                        LD H,0                          ;
                        LD B,8                          ;
Div16a                  ADD A,A                         ;
                        ADC HL,HL                       ;
                        SBC HL,DE                       ;
                        JR NC Div16b                    ;
                        ADD HL,DE                       ;
                        DJNZ Div16a                     ;
                        JP Div8                         ;
Div16b                  INC A                           ;
                        DJNZ Div16a                     ;
                        JP Div8                         ;
Div70                   ADC A,A                         ;
                        ADD HL,HL                       ;
                        ADD HL,DE                       ;
                        CCF                             ;
                        JR NC Div61                     ;
Div60                   ADC A,A                         ;
                        ADD HL,HL                       ;
                        ADD HL,DE                       ;
                        CCF                             ;
                        JR NC Div51                     ;
Div50                   ADC A,A                         ;
                        ADD HL,HL                       ;
                        ADD HL,DE                       ;
                        CCF                             ;
                        JR NC Div41                     ;
Div40                   ADC A,A                         ;
                        ADD HL,HL                       ;
                        ADD HL,DE                       ;
                        CCF                             ;
                        JR NC Div31                     ;
Div30                   ADC A,A                         ;
                        ADD HL,HL                       ;
                        ADD HL,DE                       ;
                        CCF                             ;
                        JR NC Div21                     ;
Div20                   ADC A,A                         ;
                        ADD HL,HL                       ;
                        ADD HL,DE                       ;
                        CCF                             ;
                        JR NC Div11                     ;
Div10                   ADC A,A                         ;
                        ADD HL,HL                       ;
                        ADD HL,DE                       ;
                        CCF                             ;
                        ADC A,A                         ;
                        CPL                             ;
                        LD L,A                          ;
                        LD H,C                          ;
                        RET                             ;
                        ;
Div0                    LD HL,#0100                     ;
                        RET                             ;
;
ObjeDiv                 BIT 7,H                         ;
                        JR NZ OD1                       ;
                        ADD HL,HL                       ;
                        CALL DivHLDE                    ;
                        RET                             ;
                        ;
OD1                     LD A,L                          ;
                        CPL                             ;
                        LD L,A                          ;
                        LD A,H                          ;
                        CPL                             ;
                        LD H,A                          ;
                        INC HL                          ;
                        ADD HL,HL                       ;
                        CALL DivHLDE                    ;
                        LD A,L                          ;
                        CPL                             ;
                        LD L,A                          ;
                        LD A,H                          ;
                        CPL                             ;
                        LD H,A                          ;
                        INC HL                          ;
                        RET                             ;
;
ShapeDiv                PUSH BC                         ;
                        CALL ObjeDiv                    ;
                        POP BC                          ;
                        RET                             ;
;
MultNeg                 CALL NegHL                      ;
                        LD A,B                          ;
                        CALL MultUn                     ;
                        CALL NegHL                      ;
                        RET                             ;
;
Mult8                   LD A,B                          ;
                        OR A                            ;
                        JR Z Mulx                       ;
                        DEC A                           ;
                        JR Z Mulx0                      ;
                        INC A                           ;
                        BIT 7,H                         ;
                        JR NZ MultNeg                   ;
MultUn                  EX DE,HL                        ;
                        LD HL,0                         ;
                        LD B,L                          ;
                        RLA                             ;
                        JR NC Mul0                      ;
                        ADD HL,DE                       ;
                        ADC A,B                         ;
Mul0                    ADD HL,HL                       ;
                        RLA                             ;
                        JR NC Mul1                      ;
                        ADD HL,DE                       ;
                        ADC A,B                         ;
Mul1                    ADD HL,HL                       ;
                        RLA                             ;
                        JR NC Mul2                      ;
                        ADD HL,DE                       ;
                        ADC A,B                         ;
Mul2                    ADD HL,HL                       ;
                        RLA                             ;
                        JR NC Mul3                      ;
                        ADD HL,DE                       ;
                        ADC A,B                         ;
Mul3                    ADD HL,HL                       ;
                        RLA                             ;
                        JR NC Mul4                      ;
                        ADD HL,DE                       ;
                        ADC A,B                         ;
Mul4                    ADD HL,HL                       ;
                        RLA                             ;
                        JR NC Mul5                      ;
                        ADD HL,DE                       ;
                        ADC A,B                         ;
Mul5                    ADD HL,HL                       ;
                        RLA                             ;
                        JR NC Mul6                      ;
                        ADD HL,DE                       ;
                        ADC A,B                         ;
Mul6                    ADD HL,HL                       ;
                        RLA                             ;
                        JR NC Mul7                      ;
                        ADD HL,DE                       ;
                        ADC A,B                         ;
Mul7                    LD L,H                          ;
                        LD H,A                          ;
Mulx                    BIT 0,C                         ;
                        RET Z                           ;
                        JP NegHL                        ;
;
Mulx0                   LD L,A                          ;
                        LD H,A                          ;
                        RET                             ;
;
MultHLDE                LD B,H                          ;
                        LD C,L                          ;
                        LD HL,0                         ;
                        LD A,C                          ;
                        LD C,B                          ;
                        LD B,8                          ;
                        RRA                             ;
MulL0                   JR NC MulL1                     ;
                        ADD HL,DE                       ;
MulL1                   RR H                            ;
                        RR L                            ;
                        RRA                             ;
                        DJNZ MulL0                      ;
                        LD B,A                          ;
                        LD A,C                          ;
                        LD C,B                          ;
                        LD B,8                          ;
                        RRA                             ;
MulL2                   JR NC MulL3                     ;
                        ADD HL,DE                       ;
MulL3                   RR H                            ;
                        RR L                            ;
                        RRA                             ;
                        DJNZ MulL2                      ;
                        LD H,L                          ;
                        LD L,A                          ;
                        RET                             ;
;
SignMult                BIT 7,H                         ;
                        JR Z SM1                        ;
                        LD A,H                          ;
                        CPL                             ;
                        LD H,A                          ;
                        LD A,L                          ;
                        CPL                             ;
                        LD L,A                          ;
                        INC HL                          ;
                        BIT 7,D                         ;
                        JR Z SMn                        ;
                        LD A,D                          ;
                        CPL                             ;
                        LD D,A                          ;
                        LD A,E                          ;
                        CPL                             ;
                        LD E,A                          ;
                        INC DE                          ;
SMp                     JP MultHLDE                     ;
SMn                     CALL MultHLDE                   ;
                        LD A,H                          ;
                        CPL                             ;
                        LD H,A                          ;
                        LD A,L                          ;
                        CPL                             ;
                        LD L,A                          ;
                        INC HL                          ;
                        RET                             ;
SM1                     BIT 7,D                         ;
                        JR Z MultHLDE                   ;
                        LD A,D                          ;
                        CPL                             ;
                        LD D,A                          ;
                        LD A,E                          ;
                        CPL                             ;
                        LD E,A                          ;
                        INC DE                          ;
                        JP SMn                          ;
;
SignDiv                 BIT 7,H                         ;
                        JR Z SD1                        ;
                        LD A,H                          ;
                        CPL                             ;
                        LD H,A                          ;
                        LD A,L                          ;
                        CPL                             ;
                        LD L,A                          ;
                        INC HL                          ;
                        BIT 7,D                         ;
                        JR Z SDn                        ;
                        LD A,D                          ;
                        CPL                             ;
                        LD D,A                          ;
                        LD A,E                          ;
                        CPL                             ;
                        LD E,A                          ;
                        INC DE                          ;
SDp                     JP DivHLDE                      ;
SDn                     CALL DivHLDE                    ;
                        LD A,H                          ;
                        CPL                             ;
                        LD H,A                          ;
                        LD A,L                          ;
                        CPL                             ;
                        LD L,A                          ;
                        INC HL                          ;
                        RET                             ;
SD1                     BIT 7,D                         ;
                        JP Z DivHLDE                    ;
                        LD A,D                          ;
                        CPL                             ;
                        LD D,A                          ;
                        LD A,E                          ;
                        CPL                             ;
                        LD E,A                          ;
                        INC DE                          ;
                        JP SDn                          ;
;
CalcEdges               XOR A                           ;
                        INC H                           ;
                        DEC H                           ;
                        JR Z CalcC1b                    ;
                        BIT 7,H                         ;
                        JR NZ CalcC1a                   ;
                        OR #02                          ;
                        JP CalcC1b                      ;
                        ;
CalcC1a                 OR #01                          ;
CalcC1b                 INC D                           ;
                        DEC D                           ;
                        RET Z                           ;
                        BIT 7,D                         ;
                        JR NZ CalcC1c                   ;
                        OR #04                          ;
                        RET                             ;
                        ;
CalcC1c                 OR #08                          ;
                        RET                             ;
;
ClipThing               LD BC,128                       ;
                        CALL NegHL                      ;
                        ADD HL,BC                       ;
                        LD (ctY2),HL                    ;
                        EX DE,HL                        ;
                        CALL NegHL                      ;
                        ADD HL,BC                       ;
                        LD (ctY1),HL                    ;
                        EXX                             ;
                        LD BC,128                       ;
                        ADD HL,BC                       ;
                        LD (ctX2),HL                    ;
                        EX DE,HL                        ;
                        ADD HL,BC                       ;
                        LD (ctX1),HL                    ;
                        ;
                        LD HL,0                         ;
ctX1                    EQU $-2                         ;
                        LD DE,0                         ;
ctY1                    EQU $-2                         ;
                        CALL CalcEdges                  ;
                        LD B,A                          ;
                        LD HL,0                         ;
ctX2                    EQU $-2                         ;
                        LD DE,0                         ;
ctY2                    EQU $-2                         ;
                        CALL CalcEdges                  ;
                        LD C,A                          ;
                        OR B                            ;
                        RET Z                           ;
                        LD A,C                          ;
                        AND B                           ;
                        SCF                             ;
                        RET NZ                          ;
                        LD HL,(ctX1)                    ;
                        LD (PaX),HL                     ;
                        LD HL,(ctY1)                    ;
                        LD (PaY),HL                     ;
                        LD HL,(ctX2)                    ;
                        LD (PbX),HL                     ;
                        LD HL,(ctY2)                    ;
                        LD (PbY),HL                     ;
                        CALL ClipInner                  ;
                        RET C                           ;
                        LD HL,(PaX)                     ;
                        LD (ctX2),HL                    ;
                        LD HL,(PaY)                     ;
                        LD (ctY2),HL                    ;
                        LD HL,(ctX1)                    ;
                        LD (PbX),HL                     ;
                        LD HL,(ctY1)                    ;
                        LD (PbY),HL                     ;
                        CALL ClipInner                  ;
                        RET C                           ;
                        LD HL,(PaX)                     ;
                        LD (ctX1),HL                    ;
                        LD HL,(PaY)                     ;
                        LD (ctY1),HL                    ;
                        OR A                            ;
                        RET                             ;
                        ;
ClipInner               LD HL,0                         ;
PbX                     EQU $-2                         ;
                        LD DE,0                         ;
PbY                     EQU $-2                         ;
                        LD (PmX),HL                     ;
                        LD (PmY),DE                     ;
                        CALL CalcEdges                  ;
                        OR A                            ;
                        JR NZ C2                        ;
                        LD (PaX),HL                     ;
                        LD (PaY),DE                     ;
                        RET                             ;
                        ;
C2                      LD HL,0                         ;
PaX                     EQU $-2                         ;
                        LD DE,0                         ;
PaY                     EQU $-2                         ;
                        CALL CalcEdges                  ;
                        LD B,A                          ;
                        LD HL,0                         ;
PmX                     EQU $-2                         ;
                        LD DE,0                         ;
PmY                     EQU $-2                         ;
                        CALL CalcEdges                  ;
                        AND B                           ;
                        SCF                             ;
                        RET NZ                          ;
                        LD HL,(PmX)                     ;
                        LD DE,(PaX)                     ;
                        OR A                            ;
                        SBC HL,DE                       ;
                        SRA H                           ;
                        RR L                            ;
                        LD DE,(PaX)                     ;
                        ADD HL,DE                       ;
                        LD (PmX),HL                     ;
                        LD HL,(PmY)                     ;
                        LD DE,(PaY)                     ;
                        OR A                            ;
                        SBC HL,DE                       ;
                        SRA H                           ;
                        RR L                            ;
                        LD DE,(PaY)                     ;
                        ADD HL,DE                       ;
                        LD (PmY),HL                     ;
                        CALL TestPm                     ;
                        RET Z                           ;
                        LD HL,(PbX)                     ;
                        LD DE,(PbY)                     ;
                        CALL CalcEdges                  ;
                        LD B,A                          ;
                        LD HL,(PmX)                     ;
                        LD DE,(PmY)                     ;
                        CALL CalcEdges                  ;
                        AND B                           ;
                        JR Z C4a                        ;
                        LD (PbX),HL                     ;
                        LD (PbY),DE                     ;
                        JP C2                           ;
C4a                     LD (PaX),HL                     ;
                        LD (PaY),DE                     ;
                        LD HL,(PbX)                     ;
                        LD DE,(PbY)                     ;
                        LD (PmX),HL                     ;
                        LD (PmY),DE                     ;
                        JP C2                           ;
TestPm                  LD HL,(PmX)                     ;
                        LD DE,(PaX)                     ;
                        OR A                            ;
                        SBC HL,DE                       ;
                        JR NZ TPm1                      ;
                        LD HL,(PmY)                     ;
                        LD DE,(PaY)                     ;
                        OR A                            ;
                        SBC HL,DE                       ;
                        RET Z                           ;
TPm1                    LD HL,(PmX)                     ;
                        LD DE,(PbX)                     ;
                        OR A                            ;
                        SBC HL,DE                       ;
                        RET NZ                          ;
                        LD HL,(PmY)                     ;
                        LD DE,(PbY)                     ;
                        OR A                            ;
                        SBC HL,DE                       ;
                        RET                             ;
;
GenYTab                 LD IX,YTable                    ;
                        LD HL,#C000                     ;
                        LD C,25                         ;
CharLp                  LD B,8                          ;
CharLp1                 LD (IX),L                       ;
                        INC IXH                         ;
                        LD (IX),H                       ;
                        DEC IXH                         ;
                        INC IXL                         ;
                        LD DE,#800                      ;
                        ADD HL,DE                       ;
                        DJNZ CharLp1                    ;
                        LD DE,80-8*#800                 ;
                        ADD HL,DE                       ;
                        DEC C                           ;
                        JR NZ CharLp                    ;
                        LD B,56                         ;
GYT1                    LD (IX),0                       ;
                        INC IXH                         ;
                        LD (IX),0                       ;
                        DEC IXH                         ;
                        INC IXL                         ;
                        DJNZ GYT1                       ;
                        RET                             ;
;
PALL                    LD BC,#7F10                     ;
                        OUT (C),C                       ;
                        LD C,#54                        ;
                        OUT (C),C                       ;
                        LD HL,SubColours                ;
                        LD C,0                          ;
PALL1                   XOR A                           ;
                        LD E,C                          ;
                        RR E                            ;
                        RLA                             ;
                        RLCA                            ;
                        RLCA                            ;
                        RR E                            ;
                        RR E                            ;
                        RR E                            ;
                        RLA                             ;
                        LD E,A                          ;
                        LD A,C                          ;
                        AND #6                          ;
                        OR E                            ;
                        OUT (C),A                       ;
                        LD A,(HL)                       ;
                        INC HL                          ;
                        INC A                           ;
                        RET Z                           ;
                        DEC A                           ;
                        OR #40                          ;
                        OUT (C),A                       ;
                        INC C                           ;
                        JR PALL1                        ;
;
SubColours              DEFB #14                        ; 0
                        DEFB #15                        ; 1
                        DEFB #0C                        ; 2
                        DEFB #0F                        ; 3
                        DEFB #12                        ; 4
                        DEFB #13                        ; 5
                        DEFB #0A                        ; 6
                        DEFB #0B                        ; 7
                        DEFB #15                        ; 8
                        DEFB #0C                        ; 9
                        DEFB #0F                        ; A
                        DEFB #12                        ; B
                        DEFB #13                        ; C
                        DEFB #0A                        ; D
                        DEFB #0B                        ; E
                        DEFB #1F                        ; F
                        DEFB #FF                        ;
;
Gen192Tab               LD BC,DivTab                    ;
                        LD HL,90                        ;
                        LD DE,187                       ;
G192                    CALL GTab                       ;
                        LD BC,XDivTab                   ;
                        LD HL,80                        ;
                        LD DE,158                       ;
GTab                    LD A,H                          ;
                        LD (BC),A                       ;
                        ADD HL,DE                       ;
                        INC C                           ;
                        JR NZ GTab                      ;
                        RET                             ;
;
VS1                     POP HL                          ;
                        RET                             ;
;
AnyVert                 PUSH DE                         ;
                        EXX                             ;
                        CALL NegHL                      ;
                        EX DE,HL                        ;
                        CALL NegHL                      ;
                        EX DE,HL                        ;
                        OR A                            ;
                        SBC HL,DE                       ;
                        BIT 7,H                         ;
                        ADD HL,DE                       ;
                        JR Z AV1                        ;
                        EX DE,HL                        ;
AV1                     POP BC                          ;
                        ;
VertLine                PUSH HL                         ;
                        OR A                            ;
                        LD HL,128                       ;
                        ADC HL,BC                       ;
                        JP M VS1                        ;
                        INC H                           ;
                        DEC H                           ;
                        JR NZ VS1                       ;
                        LD H,XDivTab/256                ;
                        LD A,(HL)                       ;
                        OR A                            ;
                        RRA                             ;
                        LD (V1),A                       ;
                        LD A,(Colour)                   ;
                        RLA                             ;
                        LD L,A                          ;
                        LD H,BitTab/256                 ;
                        LD A,(ColourMask)               ;
                        AND (HL)                        ;
                        LD (vlCol),A                    ;
                        POP HL                          ;
                        LD BC,128                       ;
                        ADD HL,BC                       ;
                        EX DE,HL                        ;
                        ADD HL,BC                       ;
                        LD A,H                          ;
                        OR A                            ;
                        JR Z VS2                        ;
                        LD L,0                          ;
                        JP M VS2                        ;
                        LD L,#FF                        ;
VS2                     LD H,DivTab/256                 ;
                        LD A,D                          ;
                        OR A                            ;
                        JR Z VS3                        ;
                        LD E,0                          ;
                        JP M VS3                        ;
                        LD E,#FF                        ;
VS3                     LD D,DivTab/256                 ;
                        LD A,(DE)                       ;
                        SUB (HL)                        ;
                        SCF                             ;
                        RET Z                           ;
                        INC A                           ;
                        LD B,A                          ;
                        LD L,(HL)                       ;
                        LD H,YTable/256                 ;
                        LD A,0                          ;
V1                      EQU $-1                         ;
                        ADD A,(HL)                      ;
                        LD C,A                          ;
                        INC H                           ;
                        LD A,(HL)                       ;
                        ADC A,0                         ;
                        LD H,A                          ;
                        LD L,C                          ;
                        LD C,0                          ;
vlCol                   EQU $-1                         ;
                        ;
                        LD (SubTempSP),SP               ;
                        LD SP,(pLines)                  ;
                        ;
                        PUSH HL                         ;
                        LD DE,VLO                       ;
                        PUSH DE                         ;
                        LD A,B                          ;
                        SCF                             ;
                        PUSH AF                         ;
                        ;
                        LD (pLines),SP                  ;
                        LD SP,(SubTempSP)               ;
                        ;
                        LD DE,#800                      ;
vl1                     DEC B                           ;
                        RET Z                           ;
                        LD A,(HL)                       ;
                        OR C                            ;
                        LD (HL),A                       ;
                        ADD HL,DE                       ;
                        JP NC vl1                       ;
                        LD DE,80-#800*8                 ;
                        ADD HL,DE                       ;
                        LD DE,#800                      ;
                        LD A,B                          ;
                        LD (vlRem),A                    ;
                        RRCA                            ;
                        RRCA                            ;
                        RRCA                            ;
                        AND #1F                         ;
                        JR Z vl3                        ;
                        LD B,A                          ;
vl4                     LD A,(HL)                       ;
                        OR C                            ;
                        LD (HL),A                       ;
                        ADD HL,DE                       ;
                        LD A,(HL)                       ;
                        OR C                            ;
                        LD (HL),A                       ;
                        ADD HL,DE                       ;
                        LD A,(HL)                       ;
                        OR C                            ;
                        LD (HL),A                       ;
                        ADD HL,DE                       ;
                        LD A,(HL)                       ;
                        OR C                            ;
                        LD (HL),A                       ;
                        ADD HL,DE                       ;
                        LD A,(HL)                       ;
                        OR C                            ;
                        LD (HL),A                       ;
                        ADD HL,DE                       ;
                        LD A,(HL)                       ;
                        OR C                            ;
                        LD (HL),A                       ;
                        ADD HL,DE                       ;
                        LD A,(HL)                       ;
                        OR C                            ;
                        LD (HL),A                       ;
                        ADD HL,DE                       ;
                        LD A,(HL)                       ;
                        OR C                            ;
                        LD (HL),A                       ;
                        LD DE,80-#800*7                 ;
                        ADD HL,DE                       ;
                        LD DE,#800                      ;
                        DJNZ vl4                        ;
vl3                     LD A,0                          ;
vlRem                   EQU $-1                         ;
                        AND #7                          ;
                        RET Z                           ;
                        LD B,A                          ;
vl5                     LD A,(HL)                       ;
                        OR C                            ;
                        LD (HL),A                       ;
                        ADD HL,DE                       ;
                        DJNZ vl5                        ;
                        RET                             ;
;
VLO                     LD B,A                          ;
                        POP HL                          ;
                        ;
                        LD DE,#800                      ;
                        LD A,(ColourMask)               ;
                        LD C,A                          ;
Vo1                     DEC B                           ;
                        JP Z UDLret                     ;
                        LD A,(HL)                       ;
                        AND C                           ;
                        LD (HL),A                       ;
                        ADD HL,DE                       ;
                        JP NC Vo1                       ;
                        LD DE,80-#800*8                 ;
                        ADD HL,DE                       ;
                        LD DE,#800                      ;
                        LD A,B                          ;
                        LD (VoRem),A                    ;
                        RRCA                            ;
                        RRCA                            ;
                        RRCA                            ;
                        AND #1F                         ;
                        JR Z Vo3                        ;
                        LD B,A                          ;
Vo4                     LD A,(HL)                       ;
                        AND C                           ;
                        LD (HL),A                       ;
                        ADD HL,DE                       ;
                        LD A,(HL)                       ;
                        AND C                           ;
                        LD (HL),A                       ;
                        ADD HL,DE                       ;
                        LD A,(HL)                       ;
                        AND C                           ;
                        LD (HL),A                       ;
                        ADD HL,DE                       ;
                        LD A,(HL)                       ;
                        AND C                           ;
                        LD (HL),A                       ;
                        ADD HL,DE                       ;
                        LD A,(HL)                       ;
                        AND C                           ;
                        LD (HL),A                       ;
                        ADD HL,DE                       ;
                        LD A,(HL)                       ;
                        AND C                           ;
                        LD (HL),A                       ;
                        ADD HL,DE                       ;
                        LD A,(HL)                       ;
                        AND C                           ;
                        LD (HL),A                       ;
                        ADD HL,DE                       ;
                        LD A,(HL)                       ;
                        AND C                           ;
                        LD (HL),A                       ;
                        LD DE,80-#800*7                 ;
                        ADD HL,DE                       ;
                        LD DE,#800                      ;
                        DJNZ Vo4                        ;
Vo3                     LD A,0                          ;
VoRem                   EQU $-1                         ;
                        AND #7                          ;
                        JP Z UDLret                     ;
                        LD B,A                          ;
Vo5                     LD A,(HL)                       ;
                        AND C                           ;
                        LD (HL),A                       ;
                        ADD HL,DE                       ;
                        DJNZ Vo5                        ;
                        JP UDLret                       ;
;
HS1                     POP HL                          ;
                        RET                             ;
;
HpS                     DEFW 0                          ;
HpA                     DEFW 0                          ;
;
AnyHori                 EX DE,HL                        ;
                        CALL NegHL                      ;
                        PUSH HL                         ;
                        EXX                             ;
                        OR A                            ;
                        SBC HL,DE                       ;
                        BIT 7,H                         ;
                        ADD HL,DE                       ;
                        JR Z AH1                        ;
                        EX DE,HL                        ;
AH1                     POP BC                          ;
                        ;
HoriLine                PUSH HL                         ;
                        LD L,C                          ;
                        LD H,B                          ;
                        LD BC,128                       ;
                        ADD HL,BC                       ;
                        INC H                           ;
                        DEC H                           ;
                        JR NZ HS1                       ;
                        LD H,DivTab/256                 ;
                        LD L,(HL)                       ;
                        LD H,YTable/256                 ;
                        LD A,(HL)                       ;
                        LD (HLsmc1),A                   ;
                        INC H                           ;
                        LD A,(HL)                       ;
                        LD (HLsmc2),A                   ;
                        POP HL                          ;
                        LD BC,128                       ;
                        ADD HL,BC                       ;
                        LD A,H                          ;
                        OR A                            ;
                        JR Z HS2                        ;
                        LD L,0                          ;
                        JP M HS2                        ;
                        LD L,#FF                        ;
HS2                     EX DE,HL                        ;
                        ADD HL,BC                       ;
                        LD A,H                          ;
                        OR A                            ;
                        JR Z HS3                        ;
                        LD L,0                          ;
                        JP M HS3                        ;
                        LD L,#FF                        ;
HS3                     LD H,XDivTab/256                ;
                        LD D,H                          ;
                        LD A,(DE)                       ;
                        LD E,A                          ;
                        SUB (HL)                        ;
                        SCF                             ;
                        RET Z                           ;
                        LD D,(HL)                       ;
                        LD A,D                          ;
                        OR A                            ;
                        RRA                             ;
                        ADD A,0                         ;
HLsmc1                  EQU $-1                         ;
                        LD L,A                          ;
                        LD A,0                          ;
HLsmc2                  EQU $-1                         ;
                        ADC A,0                         ;
                        LD H,A                          ;
                        LD (HLhl),HL                    ;
                        LD A,D                          ;
                        AND #1                          ;
                        ADD A,8                         ;
                        LD L,A                          ;
                        LD A,(Colour)                   ;
                        ADD A,A                         ;
                        ADD A,L                         ;
                        LD L,A                          ;
                        LD H,BitTab/256                 ;
                        LD A,(ColourMask)               ;
                        AND (HL)                        ;
                        LD (AnyA),A                     ;
                        ;
                        LD A,E                          ;
                        AND #01                         ;
                        ADD A,16                        ;
                        LD L,A                          ;
                        LD A,(Colour)                   ;
                        ADD A,A                         ;
                        ADD A,L                         ;
                        LD L,A                          ;
                        LD A,(ColourMask)               ;
                        AND (HL)                        ;
                        LD (AnyA1),A                    ;
                        LD A,(Colour)                   ;
                        ADD A,24                        ;
                        LD L,A                          ;
                        LD A,(ColourMask)               ;
                        AND (HL)                        ;
                        LD C,A                          ;
                        LD A,E                          ;
                        OR A                            ;
                        RRA                             ;
                        OR A                            ;
                        RR D                            ;
                        SUB D                           ;
                        LD B,A                          ;
                        ;
                        LD (SubTempSP),SP               ;
                        LD SP,(pLines)                  ;
                        LD HL,0                         ;
HLhl                    EQU $-2                         ;
                        PUSH HL                         ;
                        LD DE,HLO                       ;
                        PUSH DE                         ;
                        SCF                             ;
                        PUSH AF                         ; NZ
                        ;
                        LD (pLines),SP                  ;
                        LD SP,(SubTempSP)               ;
                        ;
                        JR NZ HoriL                     ;
HoriS                   LD A,0                          ;
AnyA                    EQU $-1                         ;
                        AND 0                           ;
AnyA1                   EQU $-1                         ;
                        OR (HL)                         ;
                        LD (HL),A                       ;
                        RET                             ;
;
HoriL                   LD A,(AnyA)                     ;
                        OR (HL)                         ;
                        LD (HL),A                       ;
                        INC HL                          ;
                        DJNZ HoriL1                     ;
                        LD A,(AnyA1)                    ;
                        OR (HL)                         ;
                        LD (HL),A                       ;
                        RET                             ;
;
HoriL1                  LD A,C                          ;
                        OR (HL)                         ;
                        LD (HL),A                       ;
                        INC HL                          ;
                        DJNZ HoriL1                     ;
                        LD A,(AnyA1)                    ;
                        OR (HL)                         ;
                        LD (HL),A                       ;
                        RET                             ;
;
AnyLine                 OR A                            ;
                        SBC HL,DE                       ;
                        JP Z AnyVert                    ;
                        ADD HL,DE                       ;
                        ;
                        EXX                             ;
                        OR A                            ;
                        SBC HL,DE                       ;
                        JP Z AnyHori                    ;
                        ADD HL,DE                       ;
                        ;
                        CALL ClipThing                  ;
                        RET C                           ;
                        LD HL,(ctX2)                    ;
                        LD H,XDivTab/256                ;
                        LD L,(HL)                       ;
                        EX DE,HL                        ;
                        LD HL,(ctX1)                    ;
                        LD H,D                          ;
                        LD L,(HL)                       ;
                        XOR A                           ;
                        LD H,A                          ;
                        LD D,A                          ;
                        EXX                             ;
                        LD HL,(ctY2)                    ;
                        LD H,DivTab/256                 ;
                        LD L,(HL)                       ;
                        EX DE,HL                        ;
                        LD HL,(ctY1)                    ;
                        LD H,D                          ;
                        LD L,(HL)                       ;
                        LD H,A                          ;
                        LD D,A                          ;
                        PUSH IX                         ;
                        PUSH IY                         ;
                        OR A                            ;
                        SBC HL,DE                       ;
                        JR NC Lin2                      ;
                        ADD HL,DE                       ;
                        EX DE,HL                        ;
                        EXX                             ;
                        EX DE,HL                        ;
                        JR Lin1                         ;
Lin2                    ADD HL,DE                       ;
                        EXX                             ;
Lin1                    PUSH HL                         ;
                        LD A,E                          ;
                        AND #1                          ;
                        LD L,A                          ;
                        LD A,(Colour)                   ;
                        ADD A,A                         ;
                        ADD A,L                         ;
                        LD L,A                          ;
                        LD H,BitTab/256                 ;
                        LD A,(ColourMask)               ;
                        AND (HL)                        ;
                        LD (Col),A                      ;
                        LD A,#55                        ;
                        BIT 0,E                         ;
                        JR NZ Lin3                      ;
                        LD A,#AA                        ;
Lin3                    LD (Mod),A                      ;
                        LD A,E                          ;
                        RRA                             ;
                        EXX                             ;
                        PUSH DE                         ;
                        EXX                             ;
                        POP HL                          ;
                        LD H,YTable/256                 ;
                        ADD A,(HL)                      ;
                        INC H                           ;
                        LD H,(HL)                       ;
                        LD L,A                          ;
                        LD A,H                          ;
                        ADC A,0                         ;
                        LD H,A                          ;
                        EX (SP),HL                      ;
                        LD IY,Incyy                     ;
                        LD IX,Incxx                     ;
                        OR A                            ;
                        SBC HL,DE                       ;
                        ; HL = dx
                        JP P LineA                      ;
                        LD IX,Decxx                     ;
                        LD A,L                          ;
                        CPL                             ;
                        LD L,A                          ;
                        LD A,H                          ;
                        CPL                             ;
                        LD H,A                          ;
                        INC HL                          ;
LineA                   EXX                             ;
                        OR A                            ;
                        SBC HL,DE                       ;
                        JP P LineB                      ;
                        JP #188                         ;
LineB                   LD (sxxVector),IX               ;
                        PUSH HL                         ;
                        EXX                             ;
                        POP BC                          ;
                        OR A                            ;
                        SBC HL,BC                       ;
                        ADD HL,BC                       ;
                        JP M LineC                      ;
                        ; xx > yy
                        LD (HorizVector),IX             ;
                        LD C,L                          ;
                        LD B,H                          ;
                        PUSH HL                         ;
                        EXX                             ;
                        EX DE,HL                        ;
                        POP HL                          ;
                        JP Liney                        ;
                        ;
LineC                   LD (HorizVector),IY             ;
                        PUSH HL                         ;
                        PUSH BC                         ;
                        EXX                             ;
                        EX DE,HL                        ;
                        POP HL                          ;
                        POP DE                          ;
Liney                   LD C,L                          ;
                        LD B,H                          ;
                        SRA H                           ;
                        RR L                            ;
                        LD A,L                          ;
                        EXX                             ;
                        POP HL                          ;
                        EXX                             ;
                        POP IY                          ;
                        POP IX                          ;
                        EX AF,AF'                       ;
                        EXX                             ;
                        LD B,C                          ;
                        INC B                           ;
                        LD C,#AA                        ;
Mod                     EQU $-1                         ;
;
                        LD (SubTempSP),SP               ;
                        LD SP,(pLines)                  ;
                        ;
                        LD A,(sxxVector)                ;
                        LD E,A                          ;
                        LD A,(HorizVector)              ;
                        LD D,A                          ;
                        PUSH DE                         ;
                        PUSH BC                         ;
                        PUSH HL                         ;
                        ;
                        EXX                             ;
                        LD A,C                          ;
                        LD (LAn),A                      ;
                        LD D,C                          ;
                        LD A,E                          ;
                        LD (LAn1),A                     ;
                        EX AF,AF'                       ;
                        PUSH DE                         ;
                        LD HL,ALOld                     ;
                        PUSH HL                         ;
                        SCF                             ;
                        PUSH AF                         ;
                        EX AF,AF'                       ;
                        EXX                             ;
                        ;
                        LD (pLines),SP                  ;
                        LD SP,(SubTempSP)               ;
;
                        LD DE,8                         ;
Col                     EQU $-1                         ;
;
LineAlg                 LD A,(HL)                       ;
                        OR D                            ;
                        LD (HL),A                       ;
                        EX AF,AF'                       ;
                        SUB 0                           ;
LAn1                    EQU $-1                         ;
                        JR NC LineAlg1                  ;
                        ADD A,0                         ;
LAn                     EQU $-1                         ;
                        EX AF,AF'                       ;
                        DEFB #CD                        ;
sxxVector               DEFW Incxx                      ;
                        LD A,H                          ;
                        ADD A,E                         ;
                        LD H,A                          ;
                        JR C LineAlg2                   ;
                        DJNZ LineAlg                    ;
                        RET                             ;
;
LineAlg2                PUSH BC                         ;
                        LD BC,80-#800*8                 ;
                        ADD HL,BC                       ;
                        POP BC                          ;
                        DJNZ LineAlg                    ;
                        RET                             ;
;
;
LineAlg1                EX AF,AF'                       ;
                        DEFB #CD                        ;
HorizVector             DEFW Incxx                      ;
                        DJNZ LineAlg                    ;
                        RET                             ;
;
ALOld                   EX AF,AF'                       ;
                        POP DE                          ;
                        LD A,D                          ;
                        LD (ALOn1),A                    ;
                        LD A,E                          ;
                        LD (ALOn2),A                    ;
                        POP HL                          ;
                        POP BC                          ;
                        POP DE                          ;
                        LD A,E                          ;
                        ADD A,Incxx1-Incxx              ;
                        LD (ALOsxx),A                   ;
                        LD A,D                          ;
                        ADD A,Incxx1-Incxx              ;
                        LD (ALOhori),A                  ;
                        LD A,(ColourMask)               ;
                        LD (ALOn),A                     ;
                        LD DE,8                         ;
ALOn2                   EQU $-1                         ;
                        ;
ALOlp                   LD A,(HL)                       ;
                        AND 0                           ;
ALOn                    EQU $-1                         ;
                        LD (HL),A                       ;
                        EX AF,AF'                       ;
                        SUB D                           ;
                        JR NC ALO1                      ;
                        ADD A,0                         ;
ALOn1                   EQU $-1                         ;
                        EX AF,AF'                       ;
                        DEFB #CD                        ;
ALOsxx                  DEFW Incxx                      ;
                        LD A,H                          ;
                        ADD A,E                         ;
                        LD H,A                          ;
                        JR C ALO2                       ;
                        DJNZ ALOlp                      ;
                        JP UDLret                       ;
;
ALO2                    PUSH BC                         ;
                        LD BC,80-#800*8                 ;
                        ADD HL,BC                       ;
                        POP BC                          ;
                        DJNZ ALOlp                      ;
                        JP UDLret                       ;
;
ALO1                    EX AF,AF'                       ;
                        DEFB #CD                        ;
ALOhori                 DEFW Incxx                      ;
                        DJNZ ALOlp                      ;
                        JP UDLret                       ;
;
Cosine                  ADD A,64                        ;
                        ;
Sine                    OR A                            ;
                        JP M Sine2                      ;
                        BIT 6,A                         ;
                        JR Z Sine1                      ;
                        NEG                             ;
                        AND #3F                         ;
                        JR NZ Sine1a                    ;
                        LD B,0                          ;
                        LD C,0                          ;
                        RET                             ;
;
Sine2                   BIT 6,A                         ;
                        JR Z Sine3                      ;
                        NEG                             ;
                        AND #3F                         ;
                        JR NZ Sine3a                    ;
                        LD B,0                          ;
                        LD C,1                          ;
                        RET                             ;
;
Sine1                   AND #3F                         ;
Sine1a                  LD C,A                          ;
                        LD B,SineTab/256                ;
                        LD A,(BC)                       ;
                        LD B,A                          ;
                        LD C,0                          ;
                        RET                             ;
;
Sine3                   AND #3F                         ;
Sine3a                  LD C,A                          ;
                        LD B,SineTab/256                ;
                        LD A,(BC)                       ;
                        LD B,A                          ;
                        LD C,1                          ;
                        RET                             ;
;
                        RET                             ;
;
NegHL                   LD A,L                          ;
                        CPL                             ;
                        LD L,A                          ;
                        LD A,H                          ;
                        CPL                             ;
                        LD H,A                          ;
                        INC HL                          ;
                        RET                             ;
;
Floor                   EQU -#80                        ;
;             ;
TBXSub                  EQU #70                         ;
TBZf                    EQU #A0                         ;
TBZn                    EQU -#C0                        ;
;
TMX                     EQU #30                         ;
TMZf                    EQU #C0                         ;
TMZn                    EQU #40                         ;
TGX                     EQU #C                          ;
TGZn                    EQU -#90                        ;
TGZf                    EQU #40                         ;
;
SBW                     EQU -#D                         ;
SBL                     EQU #90                         ;
SBS                     EQU 18                          ;
;
MBW                     EQU -#60                        ;
MBL                     EQU #200                        ;
MBS                     EQU 40                          ;
;
ExY                     EQU -#10                        ;
ExXL                    EQU -#18                        ;
ExXR                    EQU #30                         ;
;
TBPa                    DEFW -TBXSub,TBZn               ;
                        DEFW TBXSub,TBZn                ;
                        DEFW TBXSub,TBZf                ;
                        DEFW -TBXSub,TBZf               ;
                        ;
                        DEFW -TMX,TMZn                  ;
                        DEFW TMX,TMZn                   ;
                        DEFW TMX,TMZf                   ;
                        DEFW -TMX,TMZf                  ;
                        ;
                        DEFW -TMX,TMZn                  ;
                        DEFW TMX,TMZn                   ;
                        DEFW TMX,TMZn                   ;
                        DEFW -TMX,TMZn                  ;
                        ;
                        DEFW -TGX,TGZn                  ;
                        DEFW TGX,TGZn                   ;
                        DEFW -TGX,TGZf                  ;
                        DEFW TGX,TGZf                   ;
                        ;
                        DEFW -TGX,TGZn                  ;
                        DEFW TGX,TGZn                   ;
                        DEFW -TGX,TGZf                  ;
                        DEFW TGX,TGZf                   ;
                        ;
;
RtXV                    DEFW 0                          ;
RtZV                    DEFW 0                          ;
;
xd1                     DEFW 0                          ;
xd2                     DEFW 0                          ;
xd3                     DEFW 0                          ;
xd4                     DEFW 0                          ;
xd5                     DEFW 0                          ;
xd6                     DEFW 0                          ;
xd7                     DEFW 0                          ;
xd8                     DEFW 0                          ;
;
xn1                     DEFW 0                          ;
xn2                     DEFW 0                          ;
xn3                     DEFW 0                          ;
xn4                     DEFW 0                          ;
xn5                     DEFW 0                          ;
xn6                     DEFW 0                          ;
xn7                     DEFW 0                          ;
xn8                     DEFW 0                          ;
;
zd1                     DEFW 0                          ;
zd2                     DEFW 0                          ;
zd3                     DEFW 0                          ;
zd4                     DEFW 0                          ;
zd5                     DEFW 0                          ;
zd6                     DEFW 0                          ;
zd7                     DEFW 0                          ;
zd8                     DEFW 0                          ;
;
;
zn1                     DEFW 0                          ;
zn2                     DEFW 0                          ;
zn3                     DEFW 0                          ;
zn4                     DEFW 0                          ;
zn5                     DEFW 0                          ;
zn6                     DEFW 0                          ;
zn7                     DEFW 0                          ;
zn8                     DEFW 0                          ;
;
xv0                     DEFW 0                          ;
xv1                     DEFW 0                          ;
xv2                     DEFW 0                          ;
xv3                     DEFW 0                          ;
xv4                     DEFW 0                          ;
;
yv1                     DEFW 0                          ;
yv2                     DEFW 0                          ;
yv3                     DEFW 0                          ;
yv4                     DEFW 0                          ;
;
xv5                     DEFW 0                          ;
xv6                     DEFW 0                          ;
xv7                     DEFW 0                          ;
xv8                     DEFW 0                          ;
;
yv5                     DEFW 0                          ;
yv6                     DEFW 0                          ;
yv7                     DEFW 0                          ;
yv8                     DEFW 0                          ;
;
xv9                     DEFW 0                          ;
xvA                     DEFW 0                          ;
xvB                     DEFW 0                          ;
xvC                     DEFW 0                          ;
;
yv9                     DEFW 0                          ;
yvA                     DEFW 0                          ;
yvB                     DEFW 0                          ;
yvC                     DEFW 0                          ;
;
cY                      DEFW 0                          ;
DrawBaseF               DEFB 0                          ;
;
pLines                  DEFW 0                          ;
pOLines                 DEFW 0                          ;
SubTempSP               DEFW 0                          ;
;
                        align 256                       ;
;
BitTab                  DEFB #00,#00,#22,#11,#88,#44,#AA,#55;
                        ;
                        DEFB #00,#00,#33,#11,#CC,#44,#FF,#55;
                        ;
                        DEFB #00,#00,#22,#33,#88,#CC,#AA,#FF;
                        ;
                        DEFB #00,#33,#CC,#FF            ;
;
Incxx                   RRC D                           ;
                        RRC C                           ;
                        RET NC                          ;
                        RLC D                           ;
                        RLC D                           ;
                        INC HL                          ;
                        RET                             ;
;
Decxx                   RLC D                           ;
                        RLC C                           ;
                        RET NC                          ;
                        RRC D                           ;
                        RRC D                           ;
                        DEC HL                          ;
                        RET                             ;
;
Incyy                   LD A,H                          ;
                        ADD A,E                         ;
                        LD H,A                          ;
                        RET NC                          ;
                        PUSH BC:LD BC,80-#800*8:ADD HL,BC:POP BC;
                        RET                             ;
;
Incxx1                  RRC C                           ;
                        RET NC                          ;
                        INC HL                          ;
                        RET                             ;
;
                        RRC D                           ;
                        RLC D                           ;
                        RLC D                           ;
;
Decxx1                  RLC C                           ;
                        RET NC                          ;
                        DEC HL                          ;
                        RET                             ;
;
                        RLC D                           ;
                        RRC D                           ;
                        RRC D                           ;
;
Incyy1                  LD A,H                          ;
                        ADD A,E                         ;
                        LD H,A                          ;
                        RET NC                          ;
                        PUSH BC:LD BC,80-#800*8:ADD HL,BC:POP BC;
                        RET                             ;

; Sound bytes, a block of 13

nfA                     DEFW 20000                      ;
nfB                     DEFW 0                          ;
nfC                     DEFW 20001                      ;
nfN                     DEFB 0                          ;
nEnables                DEFB 0                          ;
nvA                     DEFB 0                          ;
nvB                     DEFB 0                          ;
nvC                     DEFB 0                          ;
nEnv                    DEFW 0                          ;


                        align 256                       ;
;
SquareTab1              DEFS 256                        ;
SquareTab2              DEFS 256                        ;
RMulSin                 DEFS 64                         ;
RMulCos                 DEFS 64                         ;
RMulSinA                DEFS 64                         ;
RMulCosA                DEFS 64                         ;
;
;
Points                  EQU $                           ;
ShellAx                 DEFS 2                          ;
ShellAy                 DEFS 2                          ;
ShellBx                 DEFS 2                          ;
ShellBy                 DEFS 2                          ;
                        ;
                        DEFS 2                          ;
ShellAy1                DEFS 2                          ;
                        DEFS 2                          ;
ShellBy1                DEFS 2                          ;
                        ;
ShellCx                 DEFS 2                          ;
ShellCy                 DEFS 2                          ;
;
                        DEFS 12                         ;
;
BarLHS                  DEFS 2                          ;
                        DEFS 2                          ;
BarRHS                  DEFS 2                          ;
                        DEFS 10                         ;
BarAx                   DEFS 2                          ;
BarAy                   DEFS 2                          ;
BarBx                   DEFS 2                          ;
BarBy                   DEFS 2                          ;
BarCx                   DEFS 2                          ;
BarCy                   DEFS 2                          ;
BarDx                   DEFS 2                          ;
BarDy                   DEFS 2                          ;
;
                        DEFS 2                          ;
BarAy1                  DEFS 2                          ;
                        DEFS 2                          ;
BarBy1                  DEFS 2                          ;
                        DEFS 2                          ;
BarCy1                  DEFS 2                          ;
                        DEFS 2                          ;
BarDy1                  DEFS 2                          ;
;
                        align 256                       ;
SineTab                 DEFB 1, #6, #D,#13              ; Hack !
                        DEFB #19,#1F,#26,#2C            ;
                        DEFB #32,#38,#3E,#44            ;
                        DEFB #4A,#50,#56,#5C            ;
                        DEFB #62,#68,#6D,#73            ;
                        DEFB #79,#7E,#84,#89            ;
                        DEFB #8E,#93,#98,#9D            ;
                        DEFB #A2,#A7,#AC,#B1            ;
                        DEFB #B5,#B9,#BE,#C2            ;
                        DEFB #C6,#CA,#CE,#D1            ;
                        DEFB #D5,#D8,#DC,#DF            ;
                        DEFB #E2,#E5,#E7,#EA            ;
                        DEFB #ED,#EF,#F1,#F3            ;
                        DEFB #F5,#F7,#F8,#FA            ;
                        DEFB #FB,#FC,#FD,#FE            ;
                        DEFB #FF,#FF, 0, 0              ;

